Imports System.Windows.Forms

Public Class DlgSampleSetup

    Private m_SampleColumn As Integer
    Private m_SampleVolume As Double
    Private m_BeadVolume As Double
    Private m_ElutionVolume As Double

    ' If true then adapters are pre-broadcasted. Else adapters will be broadcasted on deck
    Private m_IsPreBroadcastAdapters As Boolean

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click

        Try
            m_SampleColumn = Convert.ToInt32(tbxSampleColumn.Text)
            If m_SampleColumn > 12 Or m_SampleColumn < 1 Then
                MessageBox.Show("Please enter a value between 1 and 12", "Value out of Range", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If

        Catch ex As Exception
            MessageBox.Show("Please enter a value between 1 - 12 into the text box", "Enter Sample Column", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End Try

        Try
            m_SampleVolume = Convert.ToSingle(tbxSampleVolume.Text)
            If m_SampleVolume > 100 Or m_SampleVolume < 20 Then
                MessageBox.Show("Please enter a value between 20 and 100 ul", "Value out of Range", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If

        Catch ex As Exception
            MessageBox.Show("Please enter a value between 20 - 100 into the text box", "Enter Sample Volume", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End Try

        Try
            m_BeadVolume = Convert.ToSingle(tbxBeadVolume.Text)
            If m_BeadVolume > 115 Or m_BeadVolume < 20 Then
                MessageBox.Show("Please enter a value between 20 and 110 ul", "Value out of Range", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If

        Catch ex As Exception
            MessageBox.Show("Please enter a value between 20 - 100 into the text box", "Enter Bead Volume", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End Try

        Try
            m_ElutionVolume = Convert.ToSingle(tbxElutionVolume.Text)
            If m_ElutionVolume > 100 Or m_ElutionVolume < 10 Then
                MessageBox.Show("Please enter a value between 10 and 100 ul", "Value out of Range", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If

        Catch ex As Exception
            MessageBox.Show("Please enter a value between 10 - 100 into the text box", "Enter Elution Volume", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End Try

        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Public ReadOnly Property SampleColumn() As Integer
        Get
            Return m_SampleColumn
        End Get
    End Property

    Public ReadOnly Property IsPreBroadcastAdapters() As Boolean
        Get
            Return m_IsPreBroadcastAdapters
        End Get
    End Property
    Public ReadOnly Property SampleVolume() As Integer
        Get
            Return m_SampleVolume
        End Get
    End Property
    Public ReadOnly Property BeadVolume() As Integer
        Get
            Return m_BeadVolume
        End Get
    End Property
    Public ReadOnly Property ElutionVolume() As Integer
        Get
            Return m_ElutionVolume
        End Get
    End Property

    Private Sub Label3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label3.Click

    End Sub

    Private Sub Label4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label4.Click

    End Sub

    Private Sub tbxBeadVolume_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbxBeadVolume.TextChanged

    End Sub

    Private Sub GroupBox2_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GroupBox2.Enter

    End Sub

    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label1.Click

    End Sub
End Class
