Public Class CDeckLocation

    Private _DeckPositionNumber As Integer
    Private _MaestroConsumableName As String
    Private _ConsumableName As String
    Private _MaestroConsumableDescription As String
    Private _CustomDescription As String
    Private _NumberOfStackedConsumables As Integer
    Private _Lid As Boolean
    Private _ImageFilename As String
    Private _LocationType As Maestro.eLocationType

    Public Property DeckPositionNumber() As Integer
        Get
            DeckPositionNumber = _DeckPositionNumber
        End Get
        Set(ByVal value As Integer)
            _DeckPositionNumber = value
        End Set
    End Property

    Public Property DeckPosition() As String
        Get
            DeckPosition = LookupDeckNumberID(_DeckPositionNumber)
        End Get
        Set(ByVal value As String)
            _DeckPositionNumber = LookupDeckNumber(value)
            If _DeckPositionNumber = -1 Then
                Throw New Exception("CDeckLocation.DeckPosition: Deck Position: " & value & " is invalid.")
            End If
        End Set
    End Property

    Public Property MaestroConsumableName() As String
        Get
            MaestroConsumableName = _MaestroConsumableName
        End Get
        Set(ByVal value As String)
            _MaestroConsumableName = value
        End Set
    End Property

    Public Property ConsumableName() As String
        Get
            ConsumableName = _ConsumableName
        End Get
        Set(ByVal value As String)
            _ConsumableName = value
        End Set
    End Property

    Public Property MaestroConsumableDescription() As String
        Get
            MaestroConsumableDescription = _MaestroConsumableDescription
        End Get
        Set(ByVal value As String)
            _MaestroConsumableDescription = value
        End Set
    End Property

    Public Property CustomDescription() As String
        Get
            CustomDescription = _CustomDescription
        End Get
        Set(ByVal value As String)
            _CustomDescription = value
        End Set
    End Property

    Public Property NumberOfStackedConsumables() As Integer
        Get
            NumberOfStackedConsumables = _NumberOfStackedConsumables
        End Get
        Set(ByVal value As Integer)
            _NumberOfStackedConsumables = value
        End Set
    End Property

    Public Property ImageFilename() As String
        Get
            ImageFilename = _ImageFilename
        End Get
        Set(ByVal value As String)
            _ImageFilename = value
        End Set
    End Property

    Public Property Lid() As Boolean
        Get
            Lid = _Lid
        End Get
        Set(ByVal value As Boolean)
            _Lid = value
        End Set
    End Property

    Public Property LocationType() As Maestro.eLocationType
        Get
            LocationType = _LocationType
        End Get
        Set(ByVal value As Maestro.eLocationType)
            _LocationType = value
        End Set
    End Property

    Public Function LookupDeckNumberID(ByVal deckNum As Integer) As String
        Dim deckNumberID As String = String.Empty

        If deckNum < 6 Then
            deckNumberID = "A" & Format(deckNum)
        ElseIf deckNum < 12 Then
            deckNumberID = "B" & Format(deckNum) - 6
        ElseIf deckNum < 18 Then
            deckNumberID = "C" & Format(deckNum) - 12
        ElseIf deckNum < 24 Then
            deckNumberID = "D" & Format(deckNum) - 18
        End If

        Return deckNumberID
    End Function

    Public Function LookupDeckNumber(ByVal deckID As String) As Integer
        Dim DeckNumber As Integer

        DeckNumber = Convert.ToInt32(deckID.Substring(1, 1))
        If DeckNumber < 0 Or DeckNumber > 5 Then
            DeckNumber = -1
        Else
            Select Case deckID.Substring(0, 1)
                Case "A"
                    DeckNumber = DeckNumber
                Case "B"
                    DeckNumber = DeckNumber + 6
                Case "C"
                    DeckNumber = DeckNumber + 12
                Case "D"
                    DeckNumber = DeckNumber + 18
                Case Else
                    DeckNumber = -1
            End Select
        End If
        Return DeckNumber
    End Function

End Class
