Option Strict Off
Option Explicit On

Public Module DeckUtils

    Private _consumablesAPI As CaliperLifeSciences.Shared.Consumables.clsConsumablesAPI
    Private _MasterConsumablesList() As CaliperLifeSciences.Shared.Consumables.clsConsumable

    Public Function ReplaceImage(ByRef img As System.Drawing.Image, ByVal filePath As String) As System.Drawing.Image
        If System.IO.File.Exists(filePath) Then
            Dim fs As System.IO.FileStream = New System.IO.FileStream( _
                filePath, System.IO.FileMode.Open, System.IO.FileAccess.Read)
            Dim buffer(fs.Length) As Byte

            If Not img Is Nothing Then
                img.Dispose()
                img = Nothing
            End If

            fs.Read(buffer, 0, fs.Length)
            fs.Close()
            ReplaceImage = System.Drawing.Image.FromStream(New System.IO.MemoryStream(buffer))
        Else
            ReplaceImage = Nothing
        End If
    End Function

    Public Function ConsumableDensityAndCategory(ByVal ConsumableName As String) As String
        ConsumableDensityAndCategory = String.Empty
        Try
            Dim Cons As CaliperLifeSciences.Shared.Consumables.clsConsumable = Nothing
            Dim ReturnVal As String = String.Empty

            If _consumablesAPI Is Nothing Then
                _consumablesAPI = New CaliperLifeSciences.Shared.Consumables.clsConsumablesAPI
            End If
            If _MasterConsumablesList Is Nothing Then
                _consumablesAPI.Get_All_Consumables(_MasterConsumablesList)
            End If

            Cons = GetMasterConsumable(ConsumableName)

            If Cons Is Nothing Then
                ReturnVal = String.Empty
            Else
                ReturnVal = Cons.Density & " - " & Cons.Category
            End If

            ConsumableDensityAndCategory = ReturnVal

        Catch ex As Exception
            ' errors in Public VBA macros MUST be handled...
            ' however, since this is an unusual occurence, asking the user to
            ' manually Stop Execution of the application is a reasonable, low-risk solution
            _maestro.RaiseErrorFromVSTA(-9999, "frmDeckLayout.ConsumableDensityAndCategory", ex.Message & vbCrLf & "NOTE: Please Stop Execution of the application and call Caliper Service.")
        End Try
    End Function

    Public Function DoesConsumableExist(ByVal ConsumableName As String) As Boolean
        Try
            Dim Cons As CaliperLifeSciences.Shared.Consumables.clsConsumable = Nothing
            Dim ReturnVal As Boolean = False

            If _consumablesAPI Is Nothing Then
                _consumablesAPI = New CaliperLifeSciences.Shared.Consumables.clsConsumablesAPI
            End If
            If _MasterConsumablesList Is Nothing Then
                _consumablesAPI.Get_All_Consumables(_MasterConsumablesList)
            End If

            Cons = GetMasterConsumable(ConsumableName)

            If Cons Is Nothing Then
                ReturnVal = False
            Else
                ReturnVal = True
            End If

            DoesConsumableExist = ReturnVal

        Catch ex As Exception
            ' errors in Public VBA macros MUST be handled...
            ' however, since this is an unusual occurence, asking the user to
            ' manually Stop Execution of the application is a reasonable, low-risk solution
            _maestro.RaiseErrorFromVSTA(-9999, "frmDeckLayout.DoesConsumableExist", ex.Message & vbCrLf & "NOTE: Please Stop Execution of the application and call Caliper Service.")
        End Try
    End Function

    Public Function GetMasterConsumable(ByRef Name As String) As CaliperLifeSciences.Shared.Consumables.clsConsumable
        Dim nIndex As Short
        Dim cons As CaliperLifeSciences.Shared.Consumables.clsConsumable = Nothing

        For nIndex = 1 To UBound(_MasterConsumablesList) - 1
            If _MasterConsumablesList(nIndex).ConsumableName = Name Then
                cons = _MasterConsumablesList(nIndex)
            End If
        Next nIndex

        Return cons
    End Function

End Module