Imports System.IO
Imports System.Windows.Forms

Public Class frmDeckConfirmationPhoto

    Private Const DECKLAYOUT_ERROR_TITLE As String = "Application Deck Layout Confirmation Error"

    Public Sub LoadPhoto()
        Dim EntireDeckPhoto As String
        Try
            EntireDeckPhoto = System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), _maestro.GetGlobalVariableValue("g_DeckLayoutFolder"))
            EntireDeckPhoto = System.IO.Path.Combine(EntireDeckPhoto, _maestro.GetGlobalVariableValue("g_MajorStep"))
            EntireDeckPhoto = System.IO.Path.Combine(EntireDeckPhoto, "EntireDeckPhoto")

            If System.IO.File.Exists(EntireDeckPhoto & ".png") Then
                EntireDeckPhoto = EntireDeckPhoto & ".png"
            ElseIf System.IO.File.Exists(EntireDeckPhoto & ".jpg") Then
                EntireDeckPhoto = EntireDeckPhoto & ".jpg"
            End If
            If System.IO.File.Exists(EntireDeckPhoto) Then
                Dim img As System.Drawing.Image
                img = System.Drawing.Image.FromFile(EntireDeckPhoto)
                PictureBox1.Image = img
            End If
        Catch ex As Exception
            ' this is necessary because modal window delays appearance of Alarm Manager alarm
            MessageBox.Show(Me, "Error in frmDeckConfirmationPhoto.LoadPhoto: " & ex.Message & vbCrLf & vbCrLf & _
                "NOTE: When given the opportunity, Stop Execution of the application and call Caliper Service.", _
                DECKLAYOUT_ERROR_TITLE, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            ' since this is an unusual occurence, asking the user to
            ' manually Stop Execution of the application is a reasonable, low-risk solution
            _maestro.RaiseErrorFromVSTA(-9999, "frmDeckConfirmationPhoto.LoadPhoto", ex.Message & vbCrLf & _
                "NOTE: Please Stop Execution of the application and call Caliper Service.")
        End Try
    End Sub

    Private Sub cmdOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOK.Click
        Try
            Me.Hide()
            Close()
        Catch ex As Exception
            ' this is necessary because modal window delays appearance of Alarm Manager alarm
            MessageBox.Show(Me, "Error in frmDeckConfirmationPhoto.cmdOK_Click: " & ex.Message & vbCrLf & vbCrLf & _
                "NOTE: When given the opportunity, Stop Execution of the application and call Caliper Service.", _
                DECKLAYOUT_ERROR_TITLE, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            ' since this is an unusual occurence, asking the user to
            ' manually Stop Execution of the application is a reasonable, low-risk solution
            _maestro.RaiseErrorFromVSTA(-9999, "frmDeckConfirmationPhoto.cmdOK_Click", ex.Message & vbCrLf & _
                "NOTE: Please Stop Execution of the application and call Caliper Service.")
        End Try
    End Sub

    Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
        Try
            _maestro.SetGlobalVariableValue("g_ApplicationAborted", True)
            Me.Hide()
            Close()
        Catch ex As Exception
            _maestro.SetGlobalVariableValue("g_ApplicationAborted", True)
            _maestro.RaiseErrorFromVSTA(-9999, "Deck Layout Confirmation Form", "Unable to write to global variables:  g_NumberOfColumnsToProcess or g_IsAdapterPreBroadcast")
            Me.Hide()
            Close()
        End Try
    End Sub

    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        LoadPhoto()
    End Sub
End Class