
Imports System.IO
Imports System.Data.SqlClient
Imports System.Collections
Imports System.Collections.Generic
Public Class CAppDBData

    Dim m_AppObj As CConnectDB

    Public Sub New()
        If m_AppObj Is Nothing Then
            m_AppObj = New CConnectDB
        End If
    End Sub

    Public Sub GetApplicationExcelFile(ByVal excelFile As String, ByVal appName As String)
        ' Get back Excel file with content
        GetApplicationFile(excelFile, appName)
    End Sub

    Public Sub GetApplicationXMLFile(ByVal xmlFile As String, ByVal appName As String)
        ' Get back XML file with content
        GetApplicationFile(xmlFile, appName)
    End Sub

    Public Sub GetApplicationFile(ByRef fileName As String, ByVal appName As String)
        Dim oDBReader As SqlDataReader

        oDBReader = m_AppObj.GetFileFromDB(appName)

        ' TO DO: specify the correct DB column
        Dim byteArray() As Byte = CType(oDBReader.GetValue(5), Byte())

        oDBReader.Close()
        CloseDBConnection()

        UtilMod.ByteToFile(fileName, byteArray)
    End Sub

    Public Sub CloseDBConnection()
        Dim err As String = String.Empty
        m_AppObj.CloseSQLDBConn(err)

        If err Is Nothing Or err = String.Empty Then
            Exit Sub
        ElseIf Not err.Equals(String.Empty) Then
            Throw New Exception("CAppDBData::CloseDBConnection(): " & err)
        End If
    End Sub

    Public Function PushImagePageObjectsToDB(ByVal imgPageList As List(Of CImagePage)) As Boolean
        Dim isPushed As Boolean = False

        Try
            'Dim cDBCon As CConnectDB = New CConnectDB
            Dim err As String = String.Empty
            ' Push each image page to the dabase
            For Each obj As CImagePage In imgPageList

                If obj.ImagePageChanged Then
                    m_AppObj.UpdateImageDataTable(obj.DBID, obj.AppName, obj.ImagePageNumber, obj.Description, _
                                             obj.ImageFile, obj.DeckID, err)
                End If

                If Not err.Equals(String.Empty) Then
                    Exit For
                End If
                isPushed = True
            Next
        Catch ex As Exception
            ' TODO - add exception here
        End Try

        Return isPushed
    End Function

    Public Function CreateImageClass(ByVal dbID As String, _
                                        ByVal deckID As String, _
                                        ByVal imgFile As String, _
                                        ByVal desc As String, _
                                        ByVal pageNo As String, _
                                        ByVal appName As String, _
                                        ByVal img As System.Drawing.Image) As CImagePage

        Dim cImage As CImagePage = Nothing

        cImage = New CImagePage
        cImage.DBID = dbID
        cImage.DeckID = deckID
        cImage.ImageFile = imgFile
        cImage.Description = desc
        cImage.ImagePageNumber = pageNo
        cImage.AppName = appName
        cImage.DeckImage = img
        cImage.ImagePageChanged = True

        Return cImage
    End Function

    Public Function CheckImageByAppname(ByVal appName As String) As Boolean
        Return m_AppObj.CheckImageByAppname(appName)
    End Function

End Class
