Imports System.Data.SqlClient
Imports System.Configuration

Public Class CConnectDB

    Private m_DBConn As SqlConnection

    ' Get all images and description for this app name
    Public Function GetDBImageData(ByVal appName As String) As SqlDataReader

        Dim oDBReader As SqlDataReader
        Dim SQLStr As String = String.Empty
        Dim err As String = String.Empty

        SQLStr = "SELECT * FROM ImageData WHERE ApplicationName = '" & appName & "';"
        oDBReader = ExecuteSQLReaderCommand(SQLStr, err)
        'oDBConn.Close()
        If Not err.Equals(String.Empty) Then ' we got error message
            oDBReader = Nothing
        End If
        Return oDBReader
    End Function

    Public Function CheckImageByAppname(ByVal appName As String) As Boolean

        Dim imgExists As Boolean
        Dim oDBReader As SqlDataReader
        oDBReader = GetDBImageData(appName)
        imgExists = oDBReader.HasRows
        oDBReader.Close()
        m_DBConn.Close()
        Return imgExists

    End Function

    Public Function GetFileFromDB(ByVal appName As String) As SqlDataReader
        Dim oDBReader As SqlDataReader
        Dim SQLStr As String = String.Empty
        Dim err As String = String.Empty

        ' TO DO: haven't decided what this statement is going to be.
        SQLStr = "SELECT * FROM ImageData WHERE ApplicationName = '" & appName & "';"

        oDBReader = ExecuteSQLReaderCommand(SQLStr, err)

        If Not err.Equals(String.Empty) Then ' we got error message
            oDBReader = Nothing
        End If
        Return oDBReader
    End Function

    Public Sub UpdateImageDataTable(ByVal dbID As String, ByVal appName As String, ByVal stepNum As Integer, _
                                    ByVal desc As String, ByVal imagePath As String, _
                                    ByVal deckID As String, ByRef err As String)

        ' Call DB connection object here
        Dim oDBReader As SqlDataReader
        Dim hasRows As Boolean
        Dim SQLStr As String = String.Empty
        Dim byteArray() As Byte = Nothing
        Dim imageFile As System.IO.FileInfo
        Try
            err = String.Empty ' Make sure to set this variable to empty string at the start
            'oDBConn = OpenSQLDBConn()

            ' First check if image page already exists in database
            SQLStr = "Select * from ImageData where ImageDataID = '" & dbID & "';"
            oDBReader = ExecuteSQLReaderCommand(SQLStr, err)
            hasRows = oDBReader.HasRows ' Determines if we should update or insert operation
            oDBReader.Close()

            imageFile = New System.IO.FileInfo(imagePath)

            If imageFile.Exists() Then
                UtilMod.ImageConversion(imagePath, byteArray)
            End If

            If hasRows Then
                UpdateScreenInfoInDB(dbID, imageFile.Name, desc, byteArray, deckID, err)
            Else
                InsertScreenInfoToDB(imageFile.Name, appName, desc, byteArray, deckID, stepNum, err)
            End If

        Catch ex As Exception
            err = err & ":" & ex.Message
        End Try

    End Sub

    Private Function ExecuteSQLReaderCommand(ByVal commandText As String, ByRef err As String) As SqlDataReader
        Dim oDBReader As SqlDataReader = Nothing
        Dim oDBComm As SqlCommand
        Dim oDBConn As SqlConnection
        Try
            oDBConn = OpenSQLDBConn()
            oDBComm = m_DBConn.CreateCommand
            oDBComm.CommandType = Data.CommandType.Text
            oDBComm.Connection = m_DBConn
            oDBComm.CommandText = commandText
            oDBReader = oDBComm.ExecuteReader()
        Catch ex As Exception
            err = "CConnectDB::ExecuteSQLReaderCommand - " & ex.Message
            oDBReader = Nothing
        End Try
        Return oDBReader

    End Function

    Private Function UpdateScreenInfoInDB(ByVal supportDataID As String, ByVal imageFile As String, ByVal desc As String, ByVal byteArray As Byte(), ByVal deckID As String, ByRef err As String) As Integer
        Dim SQLStr As String
        Dim oDBComm As SqlCommand
        Dim rtCode As Integer = 0
        Try
            SQLStr = "UPDATE ImageData SET Description = '" & desc & "', name = '" & imageFile & "'" & ", deckID = '" & deckID & "' WHERE ImageDataID ='" & supportDataID & "'"
            oDBComm = New SqlCommand()
            oDBComm = m_DBConn.CreateCommand
            oDBComm.Connection = m_DBConn
            oDBComm.CommandText = SQLStr

            rtCode = oDBComm.ExecuteNonQuery()
            m_DBConn.Close()
        Catch ex As Exception
            err = "CConnectDB::UpdateDataToDB - " & ex.Message

        End Try

    End Function

    Private Function InsertScreenInfoToDB(ByVal imageFile As String, ByVal appName As String, ByVal desc As String, ByVal byteArray As Byte(), _
                                    ByVal deckID As String, ByVal stepNum As Integer, ByRef err As String) As Integer
        ' Call DB connection object here
        Dim oDBComm As SqlCommand
        Dim rtCode As Integer = 0
        Dim param As SqlParameter
        Dim SQLStr As String

        Try

            SQLStr = "INSERT INTO ImageData (ImageDataID, Name, ApplicationName, Description, Data, DeckID, PageNo) VALUES ( @ImageDataID, @imagePath, @appName, @desc, @byteArray, @deckID, @stepNum)"

            oDBComm = New SqlCommand()
            oDBComm = m_DBConn.CreateCommand
            oDBComm.Connection = m_DBConn
            oDBComm.CommandText = SQLStr

            param = New SqlParameter("@ImageDataID", Data.SqlDbType.VarChar)
            param.Value = Guid.NewGuid().ToString()
            oDBComm.Parameters.Add(param)

            param = New SqlParameter("@imagePath", Data.SqlDbType.VarChar)
            param.Value = imageFile
            oDBComm.Parameters.Add(param)

            'param = New SqlParameter("@type", Data.SqlDbType.Int)
            'param.Value = 1
            'oDBComm.Parameters.Add(param)

            param = New SqlParameter("@appName", Data.SqlDbType.VarChar)
            param.Value = appName
            oDBComm.Parameters.Add(param)

            param = New SqlParameter("@desc", Data.SqlDbType.VarChar)
            param.Value = desc
            oDBComm.Parameters.Add(param)

            param = New SqlParameter("@byteArray", Data.SqlDbType.VarBinary)
            param.Value = byteArray
            oDBComm.Parameters.Add(param)

            param = New SqlParameter("@deckID", Data.SqlDbType.VarChar)
            param.Value = deckID
            oDBComm.Parameters.Add(param)

            param = New SqlParameter("@stepNum", Data.SqlDbType.Int)
            param.Value = stepNum
            oDBComm.Parameters.Add(param)

            rtCode = oDBComm.ExecuteNonQuery()
            m_DBConn.Close()

        Catch ex As Exception
            err = "CConnectDB::InsertDataToDB - " & ex.Message
        End Try
        Return rtCode
    End Function

    ' Default function for opening access DB
    Public Function OpenSQLDBConn() As SqlConnection

        Try
            If m_DBConn Is Nothing Then
                m_DBConn = New SqlConnection
            End If

            m_DBConn.ConnectionString = My.Settings.SQLDBConn
            m_DBConn.Open()
        Catch ex As Exception
            m_DBConn = Nothing
        End Try
        Return m_DBConn
    End Function

    ' Default function for closing access DB
    Public Function CloseSQLDBConn(ByRef err As String) As Boolean
        Dim isClosed As Boolean = False
        If m_DBConn IsNot Nothing Then
            Try
                err = Nothing
                m_DBConn.Close()
                m_DBConn = Nothing
                isClosed = True
            Catch ex As Exception
                err = "Error Message: " & ex.Message
            End Try
        Else
            isClosed = True
        End If
        Return isClosed
    End Function

    Public Sub New()

    End Sub
End Class
