Imports System.Collections
Imports System.Collections.Generic

Public Class CPlateLayout

    Private m_NumberOfCols As Integer
    Private m_NumberOfRows As Integer
    Private m_NumberOfSamples As Integer

    Private m_PlateName As String
    ' The location on the Sciclone Deck....example. A2, B5...etc
    Private m_PlateDeckID As String
    Private m_ReagentList As List(Of CReagent)

    Public Property PlateName() As String
        Get
            Return m_PlateName
        End Get
        Set(ByVal value As String)
            m_PlateName = value
        End Set
    End Property

    Public Property PlateDeckID() As String
        Get
            Return m_PlateDeckID
        End Get
        Set(ByVal value As String)
            m_PlateDeckID = value
        End Set
    End Property

    Public Property NumberOfColumns() As Integer
        Get
            Return m_NumberOfCols
        End Get
        Set(ByVal value As Integer)
            m_NumberOfCols = value
        End Set
    End Property

    Public Property NumberOfRows() As Integer
        Get
            Return m_NumberOfRows
        End Get
        Set(ByVal value As Integer)
            m_NumberOfRows = value
        End Set
    End Property

    Public Property NumberOfSamples() As Integer
        Get
            Return m_NumberOfSamples
        End Get
        Set(ByVal value As Integer)
            m_NumberOfSamples = value
        End Set
    End Property

    Public Sub New()
        If m_ReagentList Is Nothing Then
            m_ReagentList = New List(Of CReagent)
        Else
            m_ReagentList.Clear()
        End If
    End Sub

    Public Sub GetColAndRowByReagentColumn(ByVal reagentColumn As String, ByVal aspirateVol As Double, ByRef row As Integer, ByRef col As Integer, ByRef aspirateColStart As Integer, ByRef errMessage As String)

        Dim reagentName As String = String.Empty
        Dim plateNameFound As String = String.Empty
        errMessage = String.Empty

        For Each reagent As CReagent In m_ReagentList
            ' Check if this is the reagent col we're looking for
            If reagent.StartColumn = reagentColumn Then
                reagentName = reagent.ReagentName
                aspirateColStart = reagent.StartColumn
                row = reagent.NumberOfRows
                Exit For
            End If
        Next


        For Each reagent As CReagent In m_ReagentList
            ' Check if this is the reagent col we're looking for
            If reagent.ReagentName = reagentName Then
                If reagent.IsSpanMultiColumns Then
                    col = col + 1
                Else
                    col = 1
                    Exit For
                End If
            End If
        Next

    End Sub

    Public Sub AddReagent(ByVal reagent As CReagent)

        If Not m_ReagentList.Contains(reagent) Then
            m_ReagentList.Add(reagent)
        End If

    End Sub
End Class
