Public Class CReadBarcode

    Public Function ReadBarcode(ByVal xmlFile As String) As CIndex

        Dim barcode As CIndex = Nothing

        If Not System.IO.File.Exists(xmlFile) Then
            System.Windows.Forms.MessageBox.Show("Unable to locate XML  file.")
            Return Nothing
        End If

        Dim indexWell As Integer
        Dim index As Integer
        index = 1

        Dim sampleMap As String = "SampleMap"
        Dim sample As CSample
        Dim sampleWell As String = String.Empty
        Dim indexName As String = String.Empty

        Dim dispRow As Integer = 0
        Dim dispCol As Integer = 0
        Dim aspRow As Integer
        Dim aspCol As Integer

        Dim aspirateCols As System.Collections.Generic.List(Of Integer) = Nothing
        Dim dispenseCols As System.Collections.Generic.List(Of Integer) = Nothing
        Dim barcodeIndexList As System.Collections.Generic.List(Of Integer) = Nothing

        Dim XMLDocument As Xml.XmlDocument = New Xml.XmlDocument
        XMLDocument.Load(xmlFile)
        Dim XmlReader As Xml.XmlReader = New Xml.XmlNodeReader(XMLDocument)

        aspirateCols = New System.Collections.Generic.List(Of Integer)
        dispenseCols = New System.Collections.Generic.List(Of Integer)
        barcodeIndexList = New System.Collections.Generic.List(Of Integer)

        Dim isOneToOneMap As Boolean = False

        barcode = New CIndex
        While XmlReader.Read()

            If XmlReader.Name.ToString() = (sampleMap & index) Then
            End If

            If XmlReader.Name.ToString.Equals("sample_well") Then
                sampleWell = XmlReader.ReadString().Trim
            End If
            If XmlReader.Name.ToString.Equals("index_well") Then

                Try
                    indexWell = Convert.ToInt32(XmlReader.ReadString().Trim)
                Catch ex As Exception
                    indexWell = 0
                End Try
            End If

            If XmlReader.Name.ToString.Equals("index_name") Then
                indexName = XmlReader.ReadString().Trim
            End If

            'When the end of each <sampleMapXX> element
            If XmlReader.Name.ToString.Equals((sampleMap & index)) And XmlReader.NodeType.ToString.Equals("EndElement") Then

                If indexWell <> 0 And Not indexName.ToUpper.Equals("NULL") Then

                    sample = New CSample

                    ' We actually don't have sample ID so we are using sample well 
                    sample.SampleID = sampleWell
                    sample.DestinationWellID = sampleWell

                    ' No pool ID so assign 0
                    sample.PoolID = 0
                    sample.IndexID = indexWell
                    sample.IndexName = indexName

                    If Not barcodeIndexList.Contains(sample.IndexID) Then
                        barcodeIndexList.Add(sample.IndexID)
                    End If

                    ' Source well ID needs to be interpreted from index ID
                    sample.SourceWellID = UtilMod.GetSourceWellIDFromIndexWell(indexWell)

                    UtilMod.GetRowColBasedOnWellID(sample.SourceWellID, aspRow, aspCol)
                    If Not aspirateCols.Contains(aspCol) Then
                        aspirateCols.Add(aspCol)
                    End If

                    UtilMod.GetRowColBasedOnWellID(sample.DestinationWellID, dispRow, dispCol)
                    If Not dispenseCols.Contains(dispCol) Then
                        dispenseCols.Add(dispCol)
                    End If

                    If index = 1 Then ' initialize
                        isOneToOneMap = (aspCol = dispCol And aspRow = dispRow)
                    Else
                        isOneToOneMap = isOneToOneMap And (aspCol = dispCol And aspRow = dispRow)
                    End If

                    barcode.AddSample(sample)

                    sampleWell = String.Empty
                    indexName = String.Empty
                    indexWell = 0

                    index = index + 1

                End If

            End If

        End While

        XmlReader.Close()


        barcode.IsOneToOneMap = isOneToOneMap
        If aspirateCols IsNot Nothing Then
            aspirateCols.Sort()
            barcode.SourceWellColumnStart = aspirateCols(0)
        End If

        If dispenseCols IsNot Nothing Then
            dispenseCols.Sort()
            barcode.DestinationWellColumnStart = dispenseCols(0)
        End If

        If barcodeIndexList IsNot Nothing Then
            barcodeIndexList.Sort()
            barcode.MaxBarcodeIndex = barcodeIndexList(barcodeIndexList.Count - 1)
            barcode.MinBarcodeIndex = barcodeIndexList(0)
        End If

        Return barcode

    End Function

End Class
