Public Class CReadIndexWorkbook

    Public Function ReadIndexWorkbook(ByVal workBookName As String, ByVal sheetName As String) As CIndex

        Dim barcode As CIndex = Nothing

        Dim i As Integer
        Dim j As Integer

        Dim dispRow As Integer = 0
        Dim dispCol As Integer = 0
        Dim aspRow As Integer
        Dim aspCol As Integer

        ' Indexing start row and end row in spreadsheet.
        Dim excelStartRow As Integer = 4
        Dim excelLastRow As Integer = 99

        Dim sampleWell As String
        Dim sample As CSample
        Dim indexName As String
        Dim indexWell As String

        Dim aspirateCols As System.Collections.Generic.List(Of Integer) = Nothing
        Dim dispenseCols As System.Collections.Generic.List(Of Integer) = Nothing
        Dim barcodeIndexList As System.Collections.Generic.List(Of Integer) = Nothing

        Dim isOneToOneMap As Boolean = False

        If Not System.IO.File.Exists(workBookName) Then
            System.Windows.Forms.MessageBox.Show("Unable to locate Excel file.")
            Return Nothing
        End If

        Dim excelObj As Object = CreateObject("Excel.Application")
        Dim objWorkBook As Object
        Dim objWorkSheet As Object
        Dim sheet As Object
        objWorkBook = excelObj.Workbooks.Open(workBookName)
        objWorkBook.Activate()
        objWorkSheet = objWorkBook.Sheets()

        If barcode Is Nothing Then ' Create a singleton object
            barcode = New CIndex
        End If

        For i = 1 To objWorkSheet.Count
            sheet = objWorkSheet(i)

            If sheet.Name.ToUpper().Equals(sheetName.ToUpper()) Then

                'lastExcelRow = sheet.Cells.SpecialCells(Microsoft.Office.Interop.Excel.XlCellType.xlCellTypeLastCell).Row()

                aspirateCols = New System.Collections.Generic.List(Of Integer)
                dispenseCols = New System.Collections.Generic.List(Of Integer)
                barcodeIndexList = New System.Collections.Generic.List(Of Integer)

                For j = excelStartRow To excelLastRow
                    sample = New CSample

                    Try
                        indexWell = Convert.ToInt32(sheet.Cells(j, 2).Value)
                    Catch ex As Exception
                        indexWell = 0
                    End Try

                    If indexWell > 0 Then

                        sampleWell = sheet.Cells(j, 1).Value
                        indexName = sheet.Cells(j, 3).Value

                        sample.SampleID = sampleWell
                        sample.DestinationWellID = sampleWell

                        sample.IndexID = indexWell
                        sample.IndexName = indexName

                        ' No pool ID so assign 0
                        sample.PoolID = 0

                        If Not barcodeIndexList.Contains(sample.IndexID) Then
                            barcodeIndexList.Add(sample.IndexID)
                        End If

                        ' Source well ID needs to be interpreted from index ID
                        sample.SourceWellID = UtilMod.GetSourceWellIDFromIndexWell(indexWell)

                        UtilMod.GetRowColBasedOnWellID(sample.SourceWellID, aspRow, aspCol)
                        If Not aspirateCols.Contains(aspCol) Then
                            aspirateCols.Add(aspCol)
                        End If

                        UtilMod.GetRowColBasedOnWellID(sample.DestinationWellID, dispRow, dispCol)
                        If Not dispenseCols.Contains(dispCol) Then
                            dispenseCols.Add(dispCol)
                        End If

                        If i = 1 Then ' initialize
                            isOneToOneMap = (aspCol = dispCol And aspRow = dispRow)
                        Else
                            isOneToOneMap = isOneToOneMap And (aspCol = dispCol And aspRow = dispRow)
                        End If

                        barcode.AddSample(sample)

                        sampleWell = String.Empty
                        indexName = String.Empty
                        indexWell = 0
                    End If
                Next

                Exit For

            End If
        Next

        objWorkBook.Close()
        excelObj.Quit()
        excelObj = Nothing
        objWorkBook = Nothing

        barcode.IsOneToOneMap = isOneToOneMap
        If aspirateCols IsNot Nothing Then
            aspirateCols.Sort()
            barcode.SourceWellColumnStart = aspirateCols(0)
        End If

        If dispenseCols IsNot Nothing Then
            dispenseCols.Sort()
            barcode.DestinationWellColumnStart = dispenseCols(0)
        End If

        If barcodeIndexList IsNot Nothing Then
            barcodeIndexList.Sort()
            barcode.MaxBarcodeIndex = barcodeIndexList(barcodeIndexList.Count - 1)
            barcode.MinBarcodeIndex = barcodeIndexList(0)
        End If

        Return barcode

    End Function

    ' This function is basically the same as the one above.
    ' The different is that it requires the user add Excel reference to the project. 
    ' The advantage of using this function is it will not close an open workbook.
    'Public Function ReadIndexWorkbook(ByVal workBookName As String, ByVal sheetName As String) As CIndex

    '    Dim barcode As CIndex = Nothing

    '    Dim excelObj As Microsoft.Office.Interop.Excel.Application
    '    Dim workBook As Microsoft.Office.Interop.Excel.Workbook
    '    Dim workSheet As Microsoft.Office.Interop.Excel.Sheets
    '    Dim sheet As Microsoft.Office.Interop.Excel.Worksheet

    '    Dim i As Integer
    '    Dim j As Integer

    '    Dim dispRow As Integer = 0
    '    Dim dispCol As Integer = 0
    '    Dim aspRow As Integer
    '    Dim aspCol As Integer

    '    ' Indexing start row and end row in spreadsheet.
    '    Dim excelStartRow As Integer = 4
    '    Dim excelLastRow As Integer = 99

    '    Dim sampleWell As String
    '    Dim sample As CSample
    '    Dim indexName As String
    '    Dim indexWell As String

    '    Dim aspirateCols As System.Collections.Generic.List(Of Integer) = Nothing
    '    Dim dispenseCols As System.Collections.Generic.List(Of Integer) = Nothing
    '    Dim barcodeIndexList As System.Collections.Generic.List(Of Integer) = Nothing

    '    Dim isOneToOneMap As Boolean = False

    '    If Not System.IO.File.Exists(workBookName) Then
    '        System.Windows.Forms.MessageBox.Show("Unable to locate Excel file.")
    '        Return Nothing
    '    End If

    '    excelObj = New Microsoft.Office.Interop.Excel.Application
    '    workBook = excelObj.Workbooks.Open(workBookName)
    '    workSheet = workBook.Sheets()

    '    If barcode Is Nothing Then ' Create a singleton object
    '        barcode = New CIndex
    '    End If

    '    For i = 1 To workSheet.Count
    '        sheet = workSheet(i)

    '        If sheet.Name.ToUpper().Equals(sheetName.ToUpper()) Then

    '            'lastExcelRow = sheet.Cells.SpecialCells(Microsoft.Office.Interop.Excel.XlCellType.xlCellTypeLastCell).Row()

    '            aspirateCols = New System.Collections.Generic.List(Of Integer)
    '            dispenseCols = New System.Collections.Generic.List(Of Integer)
    '            barcodeIndexList = New System.Collections.Generic.List(Of Integer)

    '            For j = excelStartRow To excelLastRow
    '                sample = New CSample

    '                Try
    '                    indexWell = Convert.ToInt32(sheet.Cells(j, 2).Value)
    '                Catch ex As Exception
    '                    indexWell = 0
    '                End Try

    '                If indexWell > 0 Then

    '                    sampleWell = sheet.Cells(j, 1).Value
    '                    indexName = sheet.Cells(j, 3).Value

    '                    sample.SampleID = sampleWell
    '                    sample.DestinationWellID = sampleWell

    '                    sample.IndexID = indexWell
    '                    sample.IndexName = indexName

    '                    ' No pool ID so assign 0
    '                    sample.PoolID = 0

    '                    If Not barcodeIndexList.Contains(sample.IndexID) Then
    '                        barcodeIndexList.Add(sample.IndexID)
    '                    End If

    '                    ' Source well ID needs to be interpreted from index ID
    '                    sample.SourceWellID = UtilMod.GetSourceWellIDFromIndexWell(indexWell)

    '                    UtilMod.GetRowColBasedOnWellID(sample.SourceWellID, aspRow, aspCol)
    '                    If Not aspirateCols.Contains(aspCol) Then
    '                        aspirateCols.Add(aspCol)
    '                    End If

    '                    UtilMod.GetRowColBasedOnWellID(sample.DestinationWellID, dispRow, dispCol)
    '                    If Not dispenseCols.Contains(dispCol) Then
    '                        dispenseCols.Add(dispCol)
    '                    End If

    '                    If i = 1 Then ' initialize
    '                        isOneToOneMap = (aspCol = dispCol And aspRow = dispRow)
    '                    Else
    '                        isOneToOneMap = isOneToOneMap And (aspCol = dispCol And aspRow = dispRow)
    '                    End If

    '                    barcode.AddSample(sample)

    '                    sampleWell = String.Empty
    '                    indexName = String.Empty
    '                    indexWell = 0
    '                End If
    '            Next

    '            Exit For

    '        End If
    '    Next

    '    workBook.Close(False, Nothing, Nothing)
    '    excelObj.Quit()
    '    excelObj = Nothing
    '    barcode.IsOneToOneMap = isOneToOneMap
    '    If aspirateCols IsNot Nothing Then
    '        aspirateCols.Sort()
    '        barcode.SourceWellColumnStart = aspirateCols(0)
    '    End If

    '    If dispenseCols IsNot Nothing Then
    '        dispenseCols.Sort()
    '        barcode.DestinationWellColumnStart = dispenseCols(0)
    '    End If

    '    If barcodeIndexList IsNot Nothing Then
    '        barcodeIndexList.Sort()
    '        barcode.MaxBarcodeIndex = barcodeIndexList(barcodeIndexList.Count - 1)
    '        barcode.MinBarcodeIndex = barcodeIndexList(0)
    '    End If

    '    Return barcode

    'End Function



End Class