Imports System.Drawing
Imports System.IO
Imports System.Drawing.Imaging
Imports System.Collections.Generic
Public Module UtilMod

    Private m_IndexWellToIndexIDMapList As Dictionary(Of Integer, String)


    Public Sub GetRowColBasedOnWellID(ByVal wellID As String, ByRef row As Integer, ByRef col As Integer)

        row = 0
        col = 0
        Try
            row = GetRowBasedOnRowName(wellID.Substring(0, 1))
            col = wellID.Substring(1)
        Catch ex As Exception
            ' TO DO - add exception here
        End Try

    End Sub

    Public Sub CopyFile(ByVal sourceFile As String, ByVal destinationFolder As String)
        If System.IO.File.Exists(sourceFile) Then

            'do the copy

        End If
    End Sub
    Private Function GetRowBasedOnRowName(ByVal rowName As String) As Integer
        Dim row As Integer = 0

        Select Case rowName.ToUpper()
            Case "A"
                row = 1
            Case "B"
                row = 2
            Case "C"
                row = 3
            Case "D"
                row = 4
            Case "E"
                row = 5
            Case "F"
                row = 6
            Case "G"
                row = 7
            Case "H"
                row = 8
        End Select

        Return row
    End Function

    Public Sub ImageConversion(ByVal imagePath As String, ByRef imageByteArray() As Byte)

        Dim image As System.Drawing.Image
        Try
            image = System.Drawing.Image.FromFile(imagePath)
            ImageToByte(image, imageByteArray)
        Catch ex As Exception
            Throw
        End Try

    End Sub


    Public Sub ImageToByte(ByVal newImage As Image, ByRef byteArray() As Byte)
        '
        Dim imageStream As MemoryStream

        Try
            ReDim byteArray(0)
            If newImage IsNot Nothing Then
                imageStream = New MemoryStream
                newImage.Save(imageStream, ImageFormat.Jpeg)
                ReDim byteArray(CInt(imageStream.Length - 1))
                imageStream.Position = 0
                imageStream.Read(byteArray, 0, CInt(imageStream.Length))
            End If
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try

    End Sub
    Public Sub ByteToImage(ByRef newImage As Image, ByVal byteArray() As Byte)
        '
        Dim imageStream As MemoryStream

        Try
            If byteArray.GetUpperBound(0) > 0 Then
                imageStream = New MemoryStream(byteArray)
                newImage = Image.FromStream(imageStream)
            Else
                newImage = Nothing
            End If
        Catch ex As Exception
            newImage = Nothing
            Throw New Exception(ex.Message)
        End Try

    End Sub


    Public Sub FileToByte(ByVal fileName As String, ByRef byteArray() As Byte)
        Dim fileStream As System.IO.FileStream = File.OpenRead(fileName) 'OpenDialog.File.OpenRead(); 

        Dim reader As BinaryReader = New BinaryReader(fileStream)
        byteArray = reader.ReadBytes(fileStream.Length)
        reader.Close()

        fileStream.Close()
    End Sub

    Public Sub ByteToFile(ByRef fileName As String, ByVal byteArray() As Byte)
        Try

            ' Read the database content into a byte array
            'Dim byteArray() As Byte = CType(oDBReader.GetValue(5), Byte())

            Dim fs As System.IO.FileStream = New System.IO.FileStream(fileName, IO.FileMode.OpenOrCreate, IO.FileAccess.Write)
            fs.Write(byteArray, 0, byteArray.GetUpperBound(0))
            fs.Close()

        Catch ex As Exception

        End Try
    End Sub

    '
    ' This function is used to convert index well to index well ID.
    ' Please see spreadsheet format for information.
    ' 

    ' Need to retrieve VSTA path from Maestro in order for this code to work.
    ' For now comment it out
    'Public Function GetSourceWellIDFromIndexWell(ByVal indexWell As Integer) As String
    '    Dim sourceWellID As String = String.Empty

    '    Dim xmlReader As Xml.XmlReader
    '    Dim indexWellToIndexIDMap As Xml.XmlDocument
    '    Dim indexWellToIndexIDMapFile As String = Environment.CurrentDirectory.Replace("\bin", "\IndexWellToWellIDMap.xml")

    '    Dim inWell As Integer
    '    Dim sampleWell As String

    '    indexWellToIndexIDMap = New Xml.XmlDocument()

    '    If (File.Exists(indexWellToIndexIDMapFile)) And m_IndexWellToIndexIDMapList Is Nothing Then

    '        m_IndexWellToIndexIDMapList = New Dictionary(Of Integer, String)

    '        indexWellToIndexIDMap.Load(indexWellToIndexIDMapFile)

    '        xmlReader = New Xml.XmlNodeReader(indexWellToIndexIDMap)

    '        ' Begin reading the xml content and put in a dictionary
    '        While xmlReader.Read()

    '            If xmlReader.Name.ToString.Equals("index_ID") Then
    '                Try
    '                    inWell = Convert.ToInt32(xmlReader.ReadString().Trim)
    '                Catch ex As Exception
    '                    inWell = 0
    '                End Try
    '            End If

    '            If xmlReader.Name.ToString.Equals("sample_well") Then
    '                sampleWell = xmlReader.ReadString().Trim

    '                ' Only add to list of they both are not 0 and empty
    '                If inWell > 0 And Not sampleWell.Equals(String.Empty) Then
    '                    m_IndexWellToIndexIDMapList.Add(inWell, sampleWell)

    '                    inWell = 0
    '                    sampleWell = String.Empty
    '                End If
    '            End If

    '        End While

    '        xmlReader.Close()
    '    End If

    '    If m_IndexWellToIndexIDMapList IsNot Nothing Then
    '        sourceWellID = m_IndexWellToIndexIDMapList.Item(indexWell).Trim()
    '    End If

    '    Return sourceWellID

    'End Function

    Public Function GetSourceWellIDFromIndexWell(ByVal indexWell As Integer) As String
        Dim sourceWellID As String = String.Empty

        Dim indexStr As String = "Index"

        indexStr = indexStr & indexWell

        sourceWellID = My.Settings.Item(indexStr)

        Return sourceWellID

    End Function

End Module
