Imports System.Windows.Forms
Imports System.IO
Public Class frmDeckSetupScreen

    Private m_ScreenName As String
    Private m_CurrentNumber As Integer

    Private m_AppFolder As String ' Get this value from Maestro global variable - see Initialize code
    Private m_AppName As String ' Get this value from Maestro global variable - see Initialize code

    Private m_IsAbort As Boolean
    Private Sub btnAbort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAbort.Click

        If MessageBox.Show("Are you sure you want to stop?", "Abort", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
            m_IsAbort = True
            Me.Close()
            'Maestro.RaiseErrorFromVBA("-999", "Startup Screen", "User has Aborted")
        End If
    End Sub



    Private Sub btnFinish_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFinish.Click

        If MessageBox.Show("Ready to Start Run?", "Finished", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
            Me.Close()
        End If

    End Sub

    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click
        m_CurrentNumber = m_CurrentNumber + 1
        UpdateScreen(m_CurrentNumber)
    End Sub

    Private Sub UpdateScreen(ByVal Number As Integer)

        Dim pictureFilename As String
        Dim textFilename As String
        Dim userText As String
        Dim lines(25) As String
        Dim index As Integer = 0

        If Number < 1 Then Exit Sub

        'update Picture and Text
        PictureFilename = m_AppFolder & m_ScreenName & "\" & "Picture" & Number & ".jpg"
        TextFilename = m_AppFolder & m_ScreenName & "\" & "Text" & Number & ".txt"

        'Check to see if both files exsist in directory
        If Directory.Exists(m_AppFolder & m_ScreenName) Then

            If File.Exists(textFilename) Then
                'update step number
                lblStepNumber.Text = "Step: " & Number

                ' Load picture
                picBox.Image = System.Drawing.Image.FromFile(pictureFilename)

                'init Load Text
                userText = ""

                ' read in each line of file
                Dim fileReader As StreamReader = New StreamReader(textFilename)
                Do While fileReader.Peek() >= 0
                    lines(index) = fileReader.ReadLine()
                    index = index + 1
                Loop
                fileReader.Close()

                ' Resize based on 

                'ReDim lines(index)

                'updated description field
                txtDesc.Lines = lines
                Me.Refresh()
            End If
        End If

    End Sub

    Private Sub btnPrevious_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrevious.Click
        m_CurrentNumber = m_CurrentNumber - 1
        If m_CurrentNumber = 0 Then
            m_CurrentNumber = 1
        End If
        UpdateScreen(m_CurrentNumber)
    End Sub

    Public Sub SetUserScreen(ByVal screenName As String, ByVal appFolder As String, ByVal appName As String)

        m_ScreenName = screenName
        m_AppFolder = appFolder
        m_AppName = appName

        Me.Text = "Application: " & appName
        lblApplication.Text = appName

        m_CurrentNumber = 1
        UpdateScreen(m_CurrentNumber)

    End Sub

    Public ReadOnly Property IsAbort() As Boolean
        Get
            Return m_IsAbort
        End Get
    End Property

End Class