Imports System.Collections.Generic
Public Class frmNorm

    Private m_NormList As List(Of CNorm)

    Private m_WorkBookname As String
    Private m_SheetName As String
    Private m_StartRow As Integer

    Private Const ROW_NUMBER As Integer = 8

    Private m_AlphaChar() As String = {"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "t", "u", "v", "w", "x", "y", "z"}
    Private m_Number() As Integer = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24}

    Private m_SampleColumn As Integer
    Private m_NumSample As Integer
    Private m_RowNum As Integer
    Private m_IsCancel As Boolean
    Private m_TotalVolume As Double

    Private Sub frmNorm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ReadNormalizationWorkbook()

        Me.lblNumberOfSamples.Text = m_NumSample
        Me.lblNumberOfCols.Text = m_SampleColumn
        Me.lblNumberOfRows.Text = m_RowNum

        Me.lblExcelFilename.Text = m_WorkBookname
        Me.lblExcelSheetName.Text = m_SheetName
        Me.lblTotalVolume.Text = m_TotalVolume

        Me.DataGridView1.DataSource = m_NormList
    End Sub

    Private Sub ReadNormalizationWorkbook()

        Dim excelObj As Microsoft.Office.Interop.Excel.Application
        Dim workBook As Microsoft.Office.Interop.Excel.Workbook
        Dim workSheet As Microsoft.Office.Interop.Excel.Sheets
        Dim sheet As Microsoft.Office.Interop.Excel.Worksheet

        Dim i As Integer
        Dim j As Integer

        Dim lastExcelRow As Integer
        Dim normClass As CNorm

        If Not System.IO.File.Exists(m_WorkBookname) Then
            System.Windows.Forms.MessageBox.Show("Unable to locate Excel file.")
            Exit Sub
        End If

        excelObj = New Microsoft.Office.Interop.Excel.Application
        workBook = excelObj.Workbooks.Open(m_WorkBookname)
        workSheet = workBook.Sheets()

        m_StartRow = 10 ' Read row starts at row 10

        For i = 1 To workSheet.Count
            sheet = workSheet(i)

            If sheet.Name.ToUpper().Equals(m_SheetName.ToUpper()) Then

                ' Read the first three lines of excel spreadsheet. This will gives us
                ' Sample column information
                Try

                    If m_NormList Is Nothing Then
                        m_NormList = New List(Of CNorm)
                    Else
                        m_NormList.Clear()
                    End If
                    m_SampleColumn = Convert.ToInt32(sheet.Cells(2, 4).Value)
                    m_NumSample = ROW_NUMBER * m_SampleColumn

                    m_TotalVolume = Convert.ToDouble(sheet.Cells(6, 4).Value)

                    lastExcelRow = sheet.Cells.SpecialCells(Microsoft.Office.Interop.Excel.XlCellType.xlCellTypeLastCell).Row()

                    For j = m_StartRow To lastExcelRow

                        ' See normalization_format.xls file to see format
                        normClass = New CNorm

                        ' 1. Read # column
                        normClass.PoundSign = sheet.Cells(j, 1).Value

                        ' 2. Read Sample Name
                        normClass.SampleID = sheet.Cells(j, 2).Value

                        ' 3. Read Sample Description
                        normClass.SampleDescription = sheet.Cells(j, 3).Value

                        ' 4. Read Peak Size
                        normClass.PeakSize = Convert.ToDouble(sheet.Cells(j, 4).Value)

                        ' 5. Read Avg. Size
                        normClass.AvgSize = Convert.ToDouble(sheet.Cells(j, 5).Value)

                        ' 6. Read Concentration
                        normClass.ConcentrationVolume = Convert.ToDouble(sheet.Cells(j, 6).Value)

                        ' 7. Read yield
                        normClass.Yield = Convert.ToDouble(sheet.Cells(j, 7).Value)

                        ' 8. Read Vol
                        normClass.Volume = Convert.ToDouble(sheet.Cells(j, 8).Value)

                        ' 9. Read Source Well
                        normClass.SourceWellID = sheet.Cells(j, 9).Value

                        ' 10 The total reaction volume
                        normClass.TotalVolume = m_TotalVolume

                        m_NormList.Add(normClass)
                    Next
                    Exit For
                Catch ex As Exception
                    Throw New Exception("ReadNormalizationWorkbook: Unable to read normalization file.")
                Finally
                    workBook.Close(False, Nothing, Nothing)
                    excelObj.Quit()
                End Try

            End If
        Next

    End Sub

    Private Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub

    Public Sub New(ByVal workBookName As String, ByVal sheetName As String)
        Me.New()

        m_WorkBookname = workBookName
        m_SheetName = sheetName

        m_RowNum = ROW_NUMBER
    End Sub

    Public ReadOnly Property NormalizationList() As List(Of CNorm)
        Get
            Return m_NormList
        End Get
    End Property

    Public ReadOnly Property NumberOfSampleColumns() As Integer
        Get
            Return m_SampleColumn
        End Get
    End Property

    Public ReadOnly Property IsCancel() As Boolean
        Get
            Return m_IsCancel
        End Get

    End Property

    Public ReadOnly Property TotalVolume() As Double
        Get
            Return m_TotalVolume
        End Get
    End Property
    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        m_IsCancel = False

        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        m_IsCancel = True
        Me.Close()
    End Sub
End Class