Imports System.Collections
Imports System.Collections.Generic

Public Enum PLATE_NUMBER
    PLATE1 = 1
    PLATE2 = 2
    PLATE3 = 3
    PLATE4 = 4
    PLATE5 = 5
End Enum

Public Class frmPlates

    Private m_NumberOfCols As Integer
    Private m_NumberOfRows As Integer
    Private m_NumberOfSamples As Integer
    Private m_Cancel As Boolean

    Public Sub BuildPlateInfo(ByVal plate As PLATE_NUMBER, ByVal plateName As String, ByVal reagentName As String, ByVal colIndex As Integer, ByVal wellList As List(Of Double))

        Dim plateLayout As frmPlateLayout
        Select Case (plate)
            Case PLATE_NUMBER.PLATE1
                plateLayout = FrmPlateLayout1
                TabPage1.Text = plateName
            Case PLATE_NUMBER.PLATE2
                plateLayout = FrmPlateLayout2
                TabPage2.Text = plateName
            Case PLATE_NUMBER.PLATE3
                plateLayout = FrmPlateLayout3
                TabPage3.Text = plateName
            Case PLATE_NUMBER.PLATE4
                plateLayout = FrmPlateLayout4
                TabPage4.Text = plateName
            Case PLATE_NUMBER.PLATE5
                plateLayout = FrmPlateLayout5
                TabPage5.Text = plateName
            Case Else
                plateLayout = FrmPlateLayout1
                TabPage1.Text = plateName
        End Select


        Select Case (colIndex - 1)
            Case 1
                plateLayout.FrmReagentControl1.ColumnNumber = 1
                plateLayout.FrmReagentControl1.ReagentName = reagentName
                plateLayout.FrmReagentControl1.ReagentName = reagentName
                plateLayout.FrmReagentControl1.UpdateReagentVolumeInAllWells(wellList)
            Case 2
                plateLayout.FrmReagentControl2.ColumnNumber = 2
                plateLayout.FrmReagentControl2.ReagentName = reagentName
                plateLayout.FrmReagentControl2.UpdateReagentVolumeInAllWells(wellList)
            Case 3
                plateLayout.FrmReagentControl3.ColumnNumber = 3
                plateLayout.FrmReagentControl3.ReagentName = reagentName
                plateLayout.FrmReagentControl3.UpdateReagentVolumeInAllWells(wellList)
            Case 4
                plateLayout.FrmReagentControl4.ColumnNumber = 4
                plateLayout.FrmReagentControl4.ReagentName = reagentName
                plateLayout.FrmReagentControl4.UpdateReagentVolumeInAllWells(wellList)
            Case 5
                plateLayout.FrmReagentControl5.ColumnNumber = 5
                plateLayout.FrmReagentControl5.ReagentName = reagentName
                plateLayout.FrmReagentControl5.UpdateReagentVolumeInAllWells(wellList)
            Case 6
                plateLayout.FrmReagentControl6.ColumnNumber = 6
                plateLayout.FrmReagentControl6.ReagentName = reagentName
                plateLayout.FrmReagentControl6.UpdateReagentVolumeInAllWells(wellList)
            Case 7
                plateLayout.FrmReagentControl7.ColumnNumber = 7
                plateLayout.FrmReagentControl7.ReagentName = reagentName
                plateLayout.FrmReagentControl7.UpdateReagentVolumeInAllWells(wellList)
            Case 8
                plateLayout.FrmReagentControl8.ColumnNumber = 8
                plateLayout.FrmReagentControl8.ReagentName = reagentName
                plateLayout.FrmReagentControl8.UpdateReagentVolumeInAllWells(wellList)
            Case 9
                plateLayout.FrmReagentControl9.ColumnNumber = 9
                plateLayout.FrmReagentControl9.ReagentName = reagentName
                plateLayout.FrmReagentControl9.UpdateReagentVolumeInAllWells(wellList)
            Case 10
                plateLayout.FrmReagentControl10.ColumnNumber = 10
                plateLayout.FrmReagentControl10.ReagentName = reagentName
                plateLayout.FrmReagentControl10.UpdateReagentVolumeInAllWells(wellList)
            Case 11
                plateLayout.FrmReagentControl11.ColumnNumber = 11
                plateLayout.FrmReagentControl11.ReagentName = reagentName
                plateLayout.FrmReagentControl11.UpdateReagentVolumeInAllWells(wellList)
            Case 12
                plateLayout.FrmReagentControl12.ColumnNumber = 12
                plateLayout.FrmReagentControl12.ReagentName = reagentName
                plateLayout.FrmReagentControl12.UpdateReagentVolumeInAllWells(wellList)
            Case Else
                ' Throw error?

        End Select
    End Sub

    Dim m_MapList As Hashtable

    Private Sub lstPlateList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstPlateList.SelectedIndexChanged
        Dim selectedPlate As String = Nothing
        Dim selectedScicloneDeckID As String = Nothing

        GetSelectedItem(selectedPlate, selectedScicloneDeckID)
        ' we are searching for Sciclone deck to highlight
        FindCorrespondingItem(selectedPlate, selectedScicloneDeckID)
        UpdateListBox(lstScicloneDeckList, selectedScicloneDeckID)

    End Sub

    Private Sub lstScicloneDeckList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstScicloneDeckList.SelectedIndexChanged
        Dim selectedPlate As String = Nothing
        Dim selectedScicloneDeckID As String = Nothing

        GetSelectedItem(selectedPlate, selectedScicloneDeckID)
        ' we are searching for plate to highlight
        FindCorrespondingItem(selectedScicloneDeckID, selectedPlate)
        UpdateListBox(lstPlateList, selectedPlate)

    End Sub

    Private Sub FindCorrespondingItem(ByVal searchItem As String, ByRef itemFound As String)

        itemFound = String.Empty

        If m_MapList IsNot Nothing Then
            For Each item As DictionaryEntry In m_MapList
                If item.Key.ToString.ToUpper.Trim.Equals(searchItem.ToUpper.Trim) Then
                    itemFound = item.Value
                    Exit For
                End If
            Next
        End If
    End Sub

    Private Sub btnMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMap.Click
        Dim selectedPlate As String = Nothing
        Dim selectedScicloneDeckID As String = Nothing

        GetSelectedItem(selectedPlate, selectedScicloneDeckID)
        ErrorProvider1.SetError(lstScicloneDeckList, Nothing)

        If selectedPlate.Equals(String.Empty) Then
            ErrorProvider1.SetError(lstScicloneDeckList, "No plate name selected. Please select the plate to be mapped.")
            Exit Sub
        End If

        If selectedScicloneDeckID.Equals(String.Empty) Then
            ErrorProvider1.SetError(lstScicloneDeckList, "No Sciclone deck selected. Please select the Sciclone deck to be mapped.")

            Exit Sub
        End If

        If m_MapList.ContainsKey(selectedPlate) Then

            If m_MapList(selectedPlate) IsNot Nothing Then
                Dim dlg As System.Windows.Forms.DialogResult

                dlg = System.Windows.Forms.MessageBox.Show("This plate is already mapped. Do you really want to change the mapping? ", "Plate Already Mapped", Windows.Forms.MessageBoxButtons.YesNo)
                If dlg = Windows.Forms.DialogResult.Yes Then
                    ' Change the value for this plate
                    If IsDeckMapped(selectedScicloneDeckID) = False Then
                        m_MapList.Item(selectedPlate) = selectedScicloneDeckID
                    End If
                End If
            Else

                If IsDeckMapped(selectedScicloneDeckID) = False Then
                    m_MapList.Item(selectedPlate) = selectedScicloneDeckID
                Else
                    ErrorProvider1.SetError(lstScicloneDeckList, "This deck is already mapped to another plate. Please selected a different deck.")
                End If
            End If
        Else
            If IsDeckMapped(selectedScicloneDeckID) = False Then
                m_MapList.Add(selectedPlate, selectedScicloneDeckID)
            End If
        End If
    End Sub

    Private Function IsDeckMapped(ByVal searchDeckID As String) As Boolean

        Dim isMapped As Boolean
        For Each item As DictionaryEntry In m_MapList

            If item.Value Is Nothing Then
                Continue For
            End If
            If item.Value.ToString.ToUpper.Trim.Equals(searchDeckID) Then
                isMapped = True
                ' This deck is already mapped to another plate. Please selected a different deck
                ErrorProvider1.SetError(lstScicloneDeckList, Nothing)
                ErrorProvider1.SetError(lstScicloneDeckList, "This deck is already mapped to another plate. Please selected a different deck.")

                Exit For
            End If
        Next
        Return isMapped
    End Function

    Private Sub btnRemoveMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemoveMap.Click

        Dim selectedPlate As String = Nothing
        Dim selectedScicloneDeckID As String = Nothing
        GetSelectedItem(selectedPlate, selectedScicloneDeckID)

        If selectedPlate.Equals(String.Empty) Or selectedScicloneDeckID.Equals(String.Empty) Then
            ErrorProvider1.SetError(lstScicloneDeckList, Nothing)
            ErrorProvider1.SetError(lstScicloneDeckList, "No mapping to be removed.")

            Exit Sub
        End If

        If m_MapList IsNot Nothing Then
            If m_MapList.ContainsKey(selectedPlate) Then
                m_MapList.Remove(selectedPlate)
            End If

            ' de-select plate and deck list boxes
            Dim i As Integer
            Dim item As String
            For i = 0 To lstScicloneDeckList.Items.Count - 1
                item = lstScicloneDeckList.Items(i)
                lstScicloneDeckList.SetSelected(i, False)
            Next
            For i = 0 To lstPlateList.Items.Count - 1
                item = lstPlateList.Items(i)
                lstPlateList.SetSelected(i, False)
            Next

        End If

    End Sub

    Private Sub GetSelectedItem(ByRef selectedPlate As String, ByRef selectedScicloneDeckID As String)


        If lstPlateList.SelectedItem IsNot Nothing Then
            selectedPlate = lstPlateList.SelectedItem.ToString().Trim()
        Else
            selectedPlate = String.Empty
        End If

        If lstScicloneDeckList.SelectedItem IsNot Nothing Then
            selectedScicloneDeckID = lstScicloneDeckList.SelectedItem.ToString().Trim()
        Else
            selectedScicloneDeckID = String.Empty
        End If
    End Sub

    Private Sub UpdateListBox(ByVal lstBox As System.Windows.Forms.ListBox, ByVal searchItem As String)

        Dim i As Integer
        Dim item As String
        If searchItem Is Nothing Then
            ' We want to de-select all items in the Sciclone deck list box
            For i = 0 To lstScicloneDeckList.Items.Count - 1
                item = lstScicloneDeckList.Items(i)
                lstScicloneDeckList.SetSelected(i, False)
            Next
            Exit Sub
        End If

        If Not searchItem.Equals(String.Empty) Then
            For i = 0 To lstBox.Items.Count - 1
                item = lstBox.Items(i)
                If searchItem.Equals(item) Then
                    lstBox.SelectedValue = searchItem
                    lstBox.SetSelected(i, True)
                    Exit For
                End If
            Next
        End If

    End Sub

    Property MapList() As Hashtable
        Get
            Return m_MapList
        End Get
        Set(ByVal value As Hashtable)
            m_MapList = value
        End Set
    End Property

    Private Sub frmPlates_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If m_MapList Is Nothing Then
            Exit Sub
        End If
        lstPlateList.Items.Clear()
        For Each item As DictionaryEntry In m_MapList
            lstPlateList.Items.Add(item.Key)
        Next

        ' Remove unused tab from showing
        Dim platesNum As Integer = Me.TabCtrlPlateLayouts.TabPages.Count - m_MapList.Count
        Dim i As Integer
        If platesNum > 0 Then
            For i = 0 To platesNum - 1
                TabCtrlPlateLayouts.TabPages.RemoveAt(TabCtrlPlateLayouts.TabPages.Count - 1)
            Next
        End If

        lblNumberOfCols.Text = m_NumberOfCols
        lblNumberOfRows.Text = m_NumberOfRows
        lblNumberOfSamples.Text = m_NumberOfSamples

    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Me.Close()
    End Sub

    Private Sub ValidatePlateMapping()
        m_Cancel = False
        If MapList.Count <= 0 Then
            m_Cancel = True
            ErrorProvider1.SetError(lstScicloneDeckList, "Please map your plates.")
            Exit Sub
        End If

        For Each item As DictionaryEntry In MapList
            If item.Value Is Nothing Then
                m_Cancel = True
                ErrorProvider1.SetError(lstScicloneDeckList, "Please map your plates.")
                Exit Sub
            End If
        Next
    End Sub

    Public ReadOnly Property Cancel() As Boolean
        Get
            Return m_Cancel
        End Get
    End Property

    Private Sub frmPlates_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        ValidatePlateMapping()

        If Not m_Cancel Then
            Me.DialogResult = Windows.Forms.DialogResult.OK
        Else
            Me.DialogResult = Windows.Forms.DialogResult.None
        End If
    End Sub


    Public WriteOnly Property NumberOfColumns() As Integer
        Set(ByVal value As Integer)
            m_NumberOfCols = value
        End Set
    End Property

    Public WriteOnly Property NumberOfRows() As Integer
        Set(ByVal value As Integer)
            m_NumberOfRows = value
        End Set
    End Property

    Public WriteOnly Property NumberOfSamples() As Integer
        Set(ByVal value As Integer)
            m_NumberOfSamples = value
        End Set
    End Property
End Class