
Imports System.Collections.Generic

Public Class frmReagentControl

    Private m_ReagentName As String
    Private m_ColNumber As Integer

    Private m_VolPerWell As Integer
    Private m_VolPerWellRemain As Integer

    ' NOTE: this list must contain 8 elements (Represents # of rows)
    '       index starts at 0
    Private m_VolPerWellList As List(Of Double)

    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()
    End Sub

    Public Sub New(ByVal reagentName As String, ByVal colNumber As Integer, ByVal volPerWellList As List(Of Double))

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        m_ReagentName = reagentName
        m_ColNumber = colNumber
        m_VolPerWellList = volPerWellList

        UpdateReagentVolumeInAllWells()
    End Sub

    Public Sub UpdateReagentVolumeInAllWells(ByVal volPerWellList As List(Of Double))
        m_VolPerWellList = volPerWellList
        UpdateReagentVolumeInAllWells()
    End Sub

    Private Sub UpdateReagentVolumeInAllWells()

        Dim i As Integer = 0

        If m_ReagentName Is Nothing Then
            m_ReagentName = String.Empty
        End If
        LblReagentName.Text = m_ReagentName.ToUpper
        LblColNumber.Text = m_ColNumber

        For Each ctrl As System.Windows.Forms.Control In Me.Controls
            If TypeOf ctrl Is System.Windows.Forms.Button Then

                For i = 0 To m_VolPerWellList.Count
                    If ctrl.Tag = (i + 1) Then

                        If m_VolPerWellList(i) >= 0 Then
                            ctrl.Text = m_VolPerWellList(i)
                        End If
                        Exit For
                    End If
                Next
            End If
        Next
        RefreshReagentControl()

    End Sub

    Public Property ColumnNumber() As Integer
        Get
            Return m_ColNumber
        End Get
        Set(ByVal value As Integer)
            m_ColNumber = value
            LblColNumber.Text = value
        End Set
    End Property

    Public Property VolumePerWell() As Double
        Get
            Return m_VolPerWell
        End Get
        Set(ByVal value As Double)
            m_VolPerWell = value
        End Set
    End Property

    Public Property ReagentName() As String
        Get
            Return m_ReagentName
        End Get
        Set(ByVal value As String)
            m_ReagentName = value
            LblReagentName.Text = value
        End Set
    End Property

    Public Sub RefreshReagentControl()

        For Each ctrl As System.Windows.Forms.Control In Me.Controls
            If TypeOf ctrl Is System.Windows.Forms.Button Then
                If ctrl.Text.Equals(String.Empty) Or ctrl.Text Is Nothing Then
                    ctrl.BackColor = Drawing.Color.Gray
                End If
            End If
        Next
    End Sub

    Private Sub LblReagentName_MouseHover(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LblReagentName.MouseHover
        ToolTip1.SetToolTip(LblReagentName, m_ReagentName)
    End Sub
End Class
