'
'   L E X A d d O n . v b
'
'   Various utilities and test routines
'
'   Last revision: 2015-03-25
'
'   Igor Hollaender, igor.hollaender@lexogen.com
'   Copyright (C) 2013-2015 Lexogen GmbH
'

Imports System.Collections.Generic
Imports System.IO
Imports System.Windows.Forms


Partial Class Maestro

    Private initialDialog As LEXdlg_Initial_dialog
    Private workDialog As LEXdlg_Work_dialog
    Private picturePresentationDialog As LEXdlg_Picture_presentation_dialog
    Private confirmationDialog As LEXdlg_Confirmation_dialog

    Private permanentDisplayThread As Threading.Thread = Nothing

    Private ReleaseID_String As String = "Release V2 2015-04-06a"
    Private Sub IH_Initialize()
    End Sub

#Region "Dialogs_management"

    Public Sub LEX_ShowDialogWorkbookSummary()
        workDialog = New LEXdlg_Work_dialog(Me)
        workDialog.ContinueButtonVisibility = True
        workDialog.CancelButtonVisibility = True
        workDialog.ContinueButtonText = "Continue"

        'IH130626 TODO try-catch block needed here to protect GetGlobalVariable
        Dim excelFile As String = Path.GetFullPath(Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), _
                                        Me.GetGlobalVariableValue("g_ExcelWorkBook"))).Replace("\", "\\")

        'IH130626 see following link for a nice RTF cookbook:
        '  http://search.cpan.org/~sburke/RTF-Writer/lib/RTF/Cookbook.pod

        Dim RTF_prolog As String = "{\rtf1   " & _
            "{\colortbl;\red0\green0\blue0;\red0\green30\blue150;} " & _
            "\fs24 \line "
        Dim RTF_epilog As String = "} "

        Dim RTF_title As String = _
            "{\pard \qc \b \fs50 \cf1 \qc Reading Workbook ...\par}"

        Dim RTF_excelFile_info As String = _
            "{\b \fs20 Details from Workbook file:} \line \line {\pard\fs18\li1000 \ri1000 \cf2 \b " & _
            excelFile & " \par} \line "

        Dim RTF_parameter_info As String = _
            "{\b \fs20 \tab Parameters:} \line {\pard\fs18\tx1000\tx5000\tx6000"

        RTF_parameter_info &= "\line \tab g_SENSE_AssayID \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AssayID") & " \line }"

        RTF_parameter_info &= "\line \tab g_SENSE_NumberOfSampleColumns \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_NumberOfSampleColumns") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_NumberOfSamples \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_NumberOfSamples") & "}"

        'IH130923 deprecated
        'RTF_parameter_info &= "\line \tab g_SENSE_RTMixType \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_RTMixType") & "}"        

        RTF_parameter_info &= "\line \tab g_SENSE_AreBeadsWashedString \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AreBeadsWashedString") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_UseOilForSealingString \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_UseOilForSealingString") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_IsRNAInputBelow10ngString \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_IsRNAInputBelow10ngString") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_LibrarySizeOptionString \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_LibrarySizeOptionString") & "}"


        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_MB \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_MB") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_HYB \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_HYB") & "}"
        'IH150130 deprecated
        'RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_ST \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_ST") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_RTST_1 \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_RTST_1") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_RTST_2 \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_RTST_2") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_RTE1 \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_RTE1") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_SE_1\tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_SE_1") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_SE_2 \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_SE_2") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_Bar_1 \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_Bar_1") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_Bar_2 \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_Bar_2") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_PE \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_PE") & "}"

        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_EtOH \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_EtOH") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_BC \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_BC") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_DPB \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_DPB") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_PS \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_PS") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_EB \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_EB") & "}"
        RTF_parameter_info &= "\line \tab g_SENSE_AvailableVolume_BW \tab {\cf2 \b " & Me.GetGlobalVariableValue("g_SENSE_AvailableVolume_BW") & "}"

        RTF_parameter_info &= "\par}"


        workDialog.LEXrtb_workDlg_Textpane_Upper.Rtf = _
            RTF_prolog & _
            RTF_title & _
            RTF_epilog

        workDialog.LEXrtb_workDlg_Textpane_Lower.Rtf = _
            RTF_prolog & _
            RTF_excelFile_info & _
            RTF_parameter_info & _
            RTF_epilog

        workDialog.ShowDialog()
        CheckDialogResult(workDialog)
        workDialog.Dispose()
    End Sub

    Public Sub LEX_ShowPermanentDisplayWithSingleLineText()
        Dim text As String = Me.GetLocalVariableValue("l_text_to_display")
        'IH130617 check text and local variable availability        
        LEX_ShowPermanentDisplay(text)
    End Sub

    Public Sub LEX_ClosePermanentDisplay()
        If permanentDisplayThread IsNot Nothing Then
            permanentDisplayThread.Abort()
            'IH130618 minor problem here: The form does not disappear until there is another cursor
            ' event (like mousemove). Proper way to close would be to send a message to the thread to close 
            ' the form
            workDialog = Nothing
        End If
    End Sub

    Private Sub LEX_ShowPermanentDisplay(ByVal text As String)
        LEX_ClosePermanentDisplay()
        permanentDisplayThread = New Threading.Thread(AddressOf LEX_ShowDialogWithSingleLineTextFromObject)
        permanentDisplayThread.IsBackground = True
        permanentDisplayThread.Start(text)
    End Sub

    Public Sub LEX_ShowInitialDialog()
        initialDialog = New LEXdlg_Initial_dialog("Phase 1: PrePCR")
        initialDialog.lbl_ReleaseID.Text = Me.ReleaseID_String
        initialDialog.ShowDialog()
        CheckDialogResult(initialDialog)
        initialDialog.Dispose()
    End Sub

    Private Sub LEX_ShowClosingDialog(ByVal messageUpper As String, ByVal messageLower As String)
        workDialog = New LEXdlg_Work_dialog(Me)
        workDialog.ContinueButtonVisibility = True
        workDialog.CancelButtonVisibility = False
        workDialog.ContinueButtonText = "Close"
        workDialog.PanelSingleLineText = messageUpper
        workDialog.LowerPanelText = messageLower
        workDialog.ShowDialog()
        CheckDialogResult(workDialog)
        workDialog.Dispose()
    End Sub

    Public Sub LEX_ShowDialogDone()
        LEX_ShowClosingDialog("DONE", "")
    End Sub

    Public Sub LEX_ShowDialogDoneWithFinalInstructions()
        LEX_ShowClosingDialog("DONE", "Phase1 is finished. Take the plate at D2, seal it, and proceed with Phase2:PCR on thermocycler.")
    End Sub

    Public Sub LEX_ShowDialogAborted()
        LEX_ShowClosingDialog("ABORTED", "")
    End Sub

    Public Sub LEX_ShowDialogWithSingleLineText()
        Dim text As String = Me.GetLocalVariableValue("l_text_to_display")
        'IH130617 TODO check text and local variable availability
        LEX_ShowDialogWithSingleLineTextFromString(text, True)
    End Sub

    'IH131105 Deprecated
    '
    'Public Sub LEX_UpdateUpperDialogBoxWithText()
    'Dim text As String = Me.GetLocalVariableValue("l_text_to_display")
    'IH130617 TODO check text and local variable availability
    '   If Not workDialog.IsDisposed Then
    '      workDialog.SetTextOfUpperRTFBox("{\rtf1 {\pard \fs50 \qc " & text & "\par}}")
    'IH130628 TODO this preformatting is very restrictive, change it
    ' End If
    'End Sub

    Public Sub LEX_UpdateLowerDialogBoxWithText()
        Dim text As String = Me.GetLocalVariableValue("l_text_to_display")
        'IH130617 TODO check text and local variable availability        
        If Not workDialog.IsDisposed Then
            workDialog.SetTextOfLowerRTFBox("{\rtf1 \line \line {\pard \fs30 \qc " & text & "\par}}")
            'IH130628 TODO this preformatting is very restrictive, change it
        End If
    End Sub

    Private Sub LEX_ShowDialogWithSingleLineTextFromObject(ByVal data As Object)
        'IH130618 dialog with invisible Continue button because this is used for permanent display
        LEX_ShowDialogWithSingleLineTextFromString(data, False)
    End Sub

    Private Sub LEX_ShowDialogWithSingleLineTextFromString(ByVal text As String, ByVal isContinueButtonVisible As Boolean)
        workDialog = New LEXdlg_Work_dialog(Me)
        workDialog.ContinueButtonVisibility = isContinueButtonVisible
        workDialog.CancelButtonVisibility = False
        'IH131105 Interesting: If workDialog.CancelButtonVisibility is set to False, 
        'a blinking 'I' cursor appears in the upper panel
        ' see also http://stackoverflow.com/questions/734032/prevent-blinking-cursor-ibeam-from-a-read-only-richtextbox

        workDialog.ContinueButtonText = "Continue"
        workDialog.PanelSingleLineText = text

        workDialog.ShowDialog()
        CheckDialogResult(workDialog)
        workDialog.Dispose()
    End Sub

    Private Sub CheckDialogResult(ByVal dialog As System.Windows.Forms.Form)
        If dialog.DialogResult = Windows.Forms.DialogResult.Cancel Then
            Me.SetGlobalVariableValue("g_ApplicationAborted", True)
            LEX_ShowDialogAborted()
        End If
    End Sub


    Public Sub LEX_ShowPicturePresentationDialog()
        picturePresentationDialog = New LEXdlg_Picture_presentation_dialog(Me)
        picturePresentationDialog.ShowDialog()
        CheckDialogResult(picturePresentationDialog)
        picturePresentationDialog.Dispose()
    End Sub


    Public Sub LEX_ShowConfirmationDialog_StartRun()
        Dim interventionInfoText As String = Me.GetLocalVariableValue("l_text_to_display")

        workDialog = New LEXdlg_Work_dialog(Me)
        workDialog.ContinueButtonVisibility = True
        workDialog.CancelButtonVisibility = True
        workDialog.ContinueButtonText = "START"
        workDialog.CancelButtonText = "Return"
        workDialog.PanelSingleLineText = "Confirm START"

        workDialog.SetTextOfLowerRTFBox("{\rtf1 \line \line {\pard \fs30 \qc " & _
        "Press {\b START} to confirm or {\b Return} to show the visual check again. \line \line " & _
        "The run of the Phase1 will take about 5.5 hours. \line \line " & _
        interventionInfoText _
        & "\par}}")

        Me.SetGlobalVariableValue("g_SENSE_StartConfirmed", False)
        If workDialog.ShowDialog() = DialogResult.OK Then
            Me.SetGlobalVariableValue("g_SENSE_StartConfirmed", True)
        End If
        workDialog.Dispose()
    End Sub


    Public Sub LEX_ShowInstructionDialog_SealPlate()
        workDialog = New LEXdlg_Work_dialog(Me)
        workDialog.ContinueButtonVisibility = True
        workDialog.CancelButtonVisibility = False
        workDialog.ContinueButtonText = "Continue"
        workDialog.CancelButtonText = "Return"
        workDialog.PanelSingleLineText = "Operator Intervention: Seal Plate at B4"

        workDialog.SetTextOfLowerRTFBox("{\rtf1 \line \line {\pard \fs30 \qc " & _
        "Take the upper plate at {\b B4},\line seal it with film,\line and place it back to the same position (B4)." & _
        "\line \line " & _
        "Then press {\b Continue}." & _
        "\par}}")

        workDialog.ShowDialog()
        workDialog.Dispose()
    End Sub


    Public Sub LEX_ShowInstructionDialog_UnsealPlate()
        workDialog = New LEXdlg_Work_dialog(Me)
        workDialog.ContinueButtonVisibility = True
        workDialog.CancelButtonVisibility = False
        workDialog.ContinueButtonText = "Continue"
        workDialog.CancelButtonText = "Return"
        workDialog.PanelSingleLineText = "Operator Intervention: Unseal Plate at D2"

        workDialog.SetTextOfLowerRTFBox("{\rtf1 \line \line {\pard \fs30 \qc " & _
        "Take the plate at {\b D2},\line spin it shortly,\line remove the sealing film,\line and place the plate back to the same position (D2)." & _
        "\line \line " & _
        "Then press {\b Continue}." & _
        "\par}}")

        workDialog.ShowDialog()
        workDialog.Dispose()
    End Sub



#End Region

#Region "Excel Workbook Management"

    Public Sub LEX_ReadSENSEWorkbook()

        Dim excelFile As String = String.Empty
        Dim excelSheet As String = String.Empty

        Try
            excelFile = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), _
                                        Me.GetGlobalVariableValue("g_ExcelWorkBook"))
        Catch ex As Exception
            Me.RaiseErrorFromVSTA(1002, "Maestro:ReadSENSEWorkbook", "Global variable g_ExcelWorkBook not defined")
        End Try
        Try
            excelSheet = Me.GetGlobalVariableValue("g_ExcelWorkSheet")
        Catch ex As Exception
            Me.RaiseErrorFromVSTA(1003, "Maestro:ReadSENSEWorkbook", "Global variable g_ExcelWorkSheet not defined")
        End Try

        'IH130625 key value pair contains the name of the variable as key, and a 2-tuple (as an int array of length 2) of (row,column) coordinates of the cell

        Dim cellDefinition As List(Of KeyValuePair(Of String, Integer())) = New List(Of KeyValuePair(Of String, Integer()))

        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_NumberOfSampleColumns", New Integer() {10, 16}))   ' this is cell P10
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_NumberOfRowsToProcess", New Integer() {9, 16}))    ' this is cell P9
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_NumberOfSamples", New Integer() {9, 7}))           ' this is cell G9
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AssayID", New Integer() {7, 7}))                     ' this is cell G7
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AreBeadsWashedString", New Integer() {10, 7}))       ' this is cell G10
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_IsRNAInputBelow10ngString", New Integer() {11, 7}))       ' this is cell G11
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_UseOilForSealingString", New Integer() {12, 7}))       ' this is cell G12
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_LibrarySizeOptionString", New Integer() {13, 7}))       ' this is cell G13

        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_MB", New Integer() {234, 15}))         ' this is cell O234
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_HYB", New Integer() {234, 14}))        ' this is cell N234
        'IH150130 ST is deprecated in V2
        'cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_ST", New Integer() {234, 13}))        ' this is cell M234
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_RTST_1", New Integer() {234, 12}))     ' this is cell L234
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_RTST_2", New Integer() {234, 11}))     ' this is cell K234
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_RTE1", New Integer() {234, 10}))        ' this is cell J234
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_SE_1", New Integer() {234, 9}))       ' this is cell I234
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_SE_2", New Integer() {234, 8}))        ' this is cell H234
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_Bar_1", New Integer() {234, 7}))    ' this is cell G234
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_Bar_2", New Integer() {234, 6}))    ' this is cell F234
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_PE", New Integer() {234, 5}))        ' this is cell E234

        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_EB", New Integer() {109, 4}))           ' this is cell D109
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_BW", New Integer() {132, 4}))             ' this is cell D132
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_EtOH", New Integer() {30, 4}))             ' this is cell D30
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_DPB", New Integer() {59, 4}))             ' this is cell D59
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_PS", New Integer() {84, 4}))             ' this is cell D84
        cellDefinition.Add(New KeyValuePair(Of String, Integer())("g_SENSE_AvailableVolume_BC", New Integer() {145, 14}))             ' this is cell N145

        ReadParametersFromWorkbookToGlobalVariables(excelFile, excelSheet, cellDefinition)


    End Sub

    Private Sub ReadParametersFromWorkbookToGlobalVariables( _
            ByVal workbookFileName As String, _
            ByVal worksheetName As String, _
            ByVal cellDefinition As List(Of KeyValuePair(Of String, Integer())))


        Dim excelObj As Object = Nothing
        Dim excelWorkbook As Object = Nothing
        Dim excelWorkSheets As Object = Nothing

        Try
            'IH130618 This is required as we are using an English Excel on a German (=nonUSEnglish) Windows system
            'see http://support.microsoft.com/kb/320369/en-us
            Dim oldCI As System.Globalization.CultureInfo = _
                System.Threading.Thread.CurrentThread.CurrentCulture
            System.Threading.Thread.CurrentThread.CurrentCulture = _
                New System.Globalization.CultureInfo("en-US")

            excelObj = CreateObject("Excel.Application")
            excelWorkbook = excelObj.Workbooks.Open(workbookFileName, False, True)  ' the third argument (True) means 'ReadOnly'
            excelWorkbook.Activate()
            excelWorkSheets = excelWorkbook.Sheets()

            For i As Integer = 1 To excelWorkSheets.Count
                If excelWorkSheets(i).Name.ToUpper().Equals(worksheetName.ToUpper()) Then
                    For Each variableAndCellPair As KeyValuePair(Of String, Integer()) In cellDefinition
                        Dim cellRow As Integer = variableAndCellPair.Value(0)
                        Dim cellColumn As Integer = variableAndCellPair.Value(1)
                        Dim cellValueObject As Object

                        cellValueObject = excelWorkSheets(i).Cells(cellRow, cellColumn).Value()

                        Try
                            Me.SetGlobalVariableValue(variableAndCellPair.Key, cellValueObject)
                        Catch ex As Exception
                            Me.RaiseErrorFromVSTA(1002, "Maestro:ReadParametersFromWorkbookToGlobalVariables", "Global variable '" _
                                        & variableAndCellPair.Key _
                                        & "' not defined, " & ex.Message)
                        End Try

                    Next
                End If
            Next

            System.Threading.Thread.CurrentThread.CurrentCulture = oldCI

            excelObj.Quit()
            excelObj = Nothing
            excelWorkbook = Nothing
            excelWorkSheets = Nothing

        Catch ex As Exception
            Me.RaiseErrorFromVSTA(1001, "Maestro:ReadParametersFromWorkbookToGlobalVariables", "Problems reading Excel workbook '" _
                & workbookFileName _
                & "': " & ex.Message)

        End Try

    End Sub


    'IH130823 this message comes after opening the .XLS file (saved from excel2007 in excel2003 format)


    '  <?xml version="1.0" encoding="UTF-8" standalone="yes" ?> 
    ' - <recoveryLog xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main">
    ' <logFileName>error023560_01.xml</logFileName> 
    ' <summary>Errors were detected in file 'C:\ProgramData\CaliperLS\Maestro\LEXOGEN\Workbooks\autoSENSE Library Prep Workbook_excel2003.xls'</summary> 
    ' - <additionalInfo>
    ' <info>This workbook has lost its VBA project, ActiveX controls and any other programmability-related features.</info> 
    ' </additionalInfo>
    ' </recoveryLog>

    ' SOLUTION: Just resave the file (againg in Excel2003 format)

#End Region

End Class
