'
'   L E X d l g _ C o n f i r m a t i o n  _ d i a l o g . v b
'
'
'   Last revision: 2013-11-05
'
'   Igor Hollaender, igor.hollaender@lexogen.com
'

Imports System.Windows.Forms

Public Class LEXdlg_Confirmation_dialog

    Public Function ShowAndReturnAnswer( _
    ByVal message As String, _
    ByVal leftButtonText As String, _
    ByVal rightButtonText As String, _
    ByVal suggestedButton As LEXDialogSuggestedButton) _
    As LEXDialogResult
        Me.LeftButtonText = leftButtonText
        Me.RightButtonText = rightButtonText
        Me.SuggestedButton = suggestedButton
        Return ShowAndReturnAnswer(message)
    End Function

    Public Function ShowAndReturnAnswer(ByVal message As String) As LEXDialogResult
        Me.lbl_Message.Text = message

        If Me.ShowDialog() = Windows.Forms.DialogResult.Yes Then
            Return LEXDialogResult.LeftButtonPressed
        Else
            Return LEXDialogResult.RightButtonPressed
        End If
    End Function

    Public WriteOnly Property SuggestedButton() As LEXDialogSuggestedButton
        Set(ByVal value As LEXDialogSuggestedButton)
            If value = LEXDialogSuggestedButton.LeftButton Then
                Me.btn_Left.BackColor = Drawing.Color.YellowGreen
                Me.btn_Right.BackColor = Drawing.Color.OliveDrab
            End If
            If value = LEXDialogSuggestedButton.RightButton Then
                Me.btn_Left.BackColor = Drawing.Color.OliveDrab
                Me.btn_Right.BackColor = Drawing.Color.YellowGreen
            End If
        End Set
    End Property

    Public WriteOnly Property LeftButtonText() As String
        Set(ByVal value As String)
            Me.btn_Left.Text = value
        End Set
    End Property

    Public WriteOnly Property RightButtonText() As String
        Set(ByVal value As String)
            Me.btn_Right.Text = value
        End Set
    End Property

    Private Sub Yes_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Left.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Yes
        Me.Close()
    End Sub

    Private Sub No_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Right.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.No
        Me.Close()
    End Sub

    Public Enum LEXDialogResult
        LeftButtonPressed
        RightButtonPressed
    End Enum

    Public Enum LEXDialogSuggestedButton
        LeftButton
        RightButton
    End Enum

End Class
