'
'   L E X d l g _ D e l a y T i m e  _ d i a l o g . v b
'
'   Delay Time Dialog
'
'   Last revision: 2013-11-05
'
'   Igor Hollaender, igor.hollaender@lexogen.com

'   Adapted from the original DlgDelayTime.vb (c) PerkinElmer
'

Imports System.Windows.Forms

Public Class LEXdlg_Delay_Time_dialog


    Private Delegate Sub UpdateTimerBox()

    Private m_IsStop As Boolean = False
    Private m_TimeRemain As String
    Private m_DelayTimeTitle As String
    Private m_EndTime As DateTime
    Private m_TimerThread As Threading.Thread

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click

        Dim confirmationDialog As LEXdlg_Confirmation_dialog = New LEXdlg_Confirmation_dialog
        If confirmationDialog.ShowAndReturnAnswer("Cancel this countdown?", "YES", "NO", LEXdlg_Confirmation_dialog.LEXDialogSuggestedButton.RightButton) _
            = LEXdlg_Confirmation_dialog.LEXDialogSuggestedButton.LeftButton Then
            m_IsStop = True
            Timer1.Enabled = False
            Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
            Me.Close()
        Else
            Me.DialogResult = Windows.Forms.DialogResult.None
        End If
        confirmationDialog.Dispose()

    End Sub

    Private Sub DlgDelayTime_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        lblDelayTitle.Text = m_DelayTimeTitle
        m_EndTime = DateAdd("s", Convert.ToDouble(m_TimeRemain), DateTime.Now)

        ' Start timer
        Timer1.Enabled = True
    End Sub

    Public ReadOnly Property StopDelay() As Boolean
        Get
            Return m_IsStop
        End Get
    End Property

    Public WriteOnly Property TimeRemain() As String
        Set(ByVal value As String)
            m_TimeRemain = value
        End Set
    End Property

    Public WriteOnly Property DelayTimeTitle() As String
        Set(ByVal value As String)
            m_DelayTimeTitle = value
        End Set
    End Property

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim endTime As DateTime = DateTime.Now
        Dim timeDiff As TimeSpan
        Dim timeStr As String
        Dim hour As String
        Dim minute As String
        Dim second As String

        timeDiff = m_EndTime - DateTime.Now
        hour = timeDiff.Hours.ToString
        If (timeDiff.Hours < 10) Then
            hour = "0" & hour
        End If
        minute = timeDiff.Minutes.ToString()
        If (timeDiff.Minutes < 10) Then
            minute = "0" & minute
        End If
        second = timeDiff.Seconds.ToString()
        If timeDiff.Seconds < 10 Then
            second = "0" & second
        End If

        timeStr = hour & ":" & minute & ":" & second 'Format(timeDiff, "HH:mm:ss")
        tbxTimer.Text = timeStr

        tbxTimer.Refresh()

        If timeDiff.TotalSeconds <= 0 Then
            Timer1.Enabled = False
            Me.Close()
        End If


    End Sub


End Class