'
'   L E X d l g _ W o r k _ d i a l o g . v b
'
'   Application Dialog Used During Operation
'
'   Last revision: 2015-03-18
'
'   Igor Hollaender, igor.hollaender@lexogen.com
'   Copyright (C)2013,2014,2015 Lexogen GmbH
'


Imports System.Collections.Generic
Imports System.IO
Imports System.Text.RegularExpressions
Imports System.Windows.Forms

Public Class LEXdlg_Work_dialog

    Protected maestroMaster As Maestro


    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LEXbtn_workdialog_Continue.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LEXbtn_workdialog_Cancel.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Sub New(ByVal m As Maestro)
        maestroMaster = m

        InitializeComponent()
    End Sub

    Public WriteOnly Property ContinueButtonVisibility() As Boolean
        Set(ByVal value As Boolean)
            Me.LEXbtn_workdialog_Continue.Visible = value
        End Set
    End Property

    Public WriteOnly Property CancelButtonVisibility() As Boolean
        Set(ByVal value As Boolean)
            Me.LEXbtn_workdialog_Cancel.Visible = value
        End Set
    End Property

    Public WriteOnly Property ContinueButtonText() As String
        Set(ByVal value As String)
            Me.LEXbtn_workdialog_Continue.Text = value
        End Set
    End Property

    Public WriteOnly Property CancelButtonText() As String
        Set(ByVal value As String)
            Me.LEXbtn_workdialog_Cancel.Text = value
        End Set
    End Property

    Public WriteOnly Property PanelSingleLineText() As String
        Set(ByVal value As String)
            Me.LEXrtb_workDlg_Textpane_Upper.SelectionAlignment = HorizontalAlignment.Center
            Me.LEXrtb_workDlg_Textpane_Upper.Rtf = "{\rtf1 \fs50 \line " & value & "}" 'IH130617 improve this
        End Set
    End Property

    Public WriteOnly Property LowerPanelText() As String
        Set(ByVal value As String)
            Me.LEXrtb_workDlg_Textpane_Lower.SelectionAlignment = HorizontalAlignment.Center
            Me.LEXrtb_workDlg_Textpane_Lower.Rtf = "{\rtf1 \fs30 \line " & value & "}" 'IH131105 improve this
        End Set
    End Property

    
    Delegate Sub SetTextOfLowerRTFBoxDelegate(ByVal rtfText As String)

    Public Sub SetTextOfLowerRTFBox(ByVal rtfText As String)
        If LEXrtb_workDlg_Textpane_Lower.InvokeRequired Then
            Dim oCall As New SetTextOfLowerRTFBoxDelegate(AddressOf SetTextOfLowerRTFBox)
            Me.BeginInvoke(oCall, New Object() {rtfText})
        Else
            LEXrtb_workDlg_Textpane_Lower.Rtf = rtfText
        End If
    End Sub

End Class


Public Class LEXdlg_Picture_presentation_dialog
    'IH130626 parts of this code are inspired by original PerkinElmer's code (frmDeckSetupScreen.vb)

    Inherits LEXdlg_Work_dialog

    Private components As System.ComponentModel.IContainer
    Private actualLocationButtonRow As Integer = 0
    Private actualLocationButtonColumn As Integer = 0
    Private picturesAndTexts As List(Of PictureAndText) = New List(Of PictureAndText)
    Private actualPictureAndTextIndexToShow As Integer 'IH130627 this is an index into picturesAndTexts or -1 if there is no such picture/text 
    '(because there was not picture/text for the given location)

    ' this is to enhance the enabled/disabled/selected difference in appearance
    Private buttonFgColorEnabled As Drawing.Color = Drawing.Color.Blue
    Private buttonBgColorEnabled As Drawing.Color = Drawing.Color.LightBlue
    Private buttonFgColorSelected As Drawing.Color = Drawing.Color.Wheat
    Private buttonBgColorSelected As Drawing.Color = Drawing.Color.Blue
    Private buttonFgColorDisabled As Drawing.Color = Drawing.Color.BlanchedAlmond
    Private buttonBgColorDisabled As Drawing.Color = Drawing.Color.White

    Sub New(ByVal maestroMaster As Maestro)
        MyBase.New(maestroMaster)

        Me.LEXbtn_PictPresDialog_Next = New System.Windows.Forms.Button
        With Me.LEXbtn_PictPresDialog_Next
            .Anchor = System.Windows.Forms.AnchorStyles.None
            .Font = New System.Drawing.Font("Calibri", 11.0!, _
                System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            .Location = New System.Drawing.Point(655, 220)
            .Name = "LEXbtn_PictPresDialog_Next"
            .Size = New System.Drawing.Size(110, 45)
            .TabIndex = 0
            .Text = "Show Next"
            .UseVisualStyleBackColor = False
        End With

        Me.LEXbtn_PictPresDialog_Previous = New System.Windows.Forms.Button
        With Me.LEXbtn_PictPresDialog_Previous
            .Anchor = System.Windows.Forms.AnchorStyles.None
            .Font = New System.Drawing.Font("Calibri", 11.0!, _
                System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            .Location = New System.Drawing.Point(540, 220)
            .Name = "LEXbtn_PictPresDialog_Previous"
            .Size = New System.Drawing.Size(110, 45)
            .TabIndex = 0
            .Text = "Show Previous"
            .UseVisualStyleBackColor = False
        End With

        Me.LEXpcb_PictPresDialog_Image = New System.Windows.Forms.PictureBox()
        With Me.LEXpcb_PictPresDialog_Image
            .Location = New System.Drawing.Point(3, 120)
            .Name = "LEXpcb_PictPresDialog_Image"
            .Size = New System.Drawing.Size(527, 397)
            .TabIndex = 6
            .BackColor = Drawing.Color.White
            .TabStop = False
            .SizeMode = PictureBoxSizeMode.Zoom
        End With

        Me.LEXlbl_PictPresDialog_LocationLabel = New System.Windows.Forms.Label()
        With Me.LEXlbl_PictPresDialog_LocationLabel
            .AutoSize = False
            .Location = New System.Drawing.Point(10, 130)
            .Size = New System.Drawing.Size(120, 70)
            .Font = New System.Drawing.Font("Microsoft Sans Serif", 50.0!, _
                System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            .Name = "LEXlbl_PictPresDialog_LocationLabel"
            .TabIndex = 11
            .Text = "MM"
            .TextAlign = Drawing.ContentAlignment.MiddleCenter
            .BackColor = Drawing.Color.Yellow
            .ForeColor = Drawing.Color.Black
        End With

        Me.LEXlbl_PictPresDialog_Description = New System.Windows.Forms.Label()
        With Me.LEXlbl_PictPresDialog_Description
            .Location = New System.Drawing.Point(536, 339)
            .Size = New System.Drawing.Size(250, 178)
            .Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, _
                System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            .Name = "LEXlbl_PictPresDialog_Description"
            .TabIndex = 11
            .Text = "Description"
            .BackColor = Drawing.Color.Beige
        End With

        Me.LEXlbl_PictPresDialog_Title = New System.Windows.Forms.Label()
        With Me.LEXlbl_PictPresDialog_Title
            .AutoSize = False
            .Font = New System.Drawing.Font("Microsoft Sans Serif", 15.0!, _
                System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            .Location = New System.Drawing.Point(-2, 78)
            .Name = "LEXlbl_PictPresDialog_Title"
            .Size = New System.Drawing.Size(Me.Size.Width, 20)
            .TabIndex = 12
            .Text = "Deck Setup Visual Check"
            .TextAlign = Drawing.ContentAlignment.MiddleCenter
        End With

        Me.IHpnl_bgpanel.Controls.Add(Me.LEXbtn_PictPresDialog_Next)
        Me.IHpnl_bgpanel.Controls.Add(Me.LEXbtn_PictPresDialog_Previous)
        Me.IHpnl_bgpanel.Controls.Add(Me.LEXlbl_PictPresDialog_LocationLabel)
        Me.IHpnl_bgpanel.Controls.Add(Me.LEXpcb_PictPresDialog_Image)
        Me.IHpnl_bgpanel.Controls.Add(Me.LEXlbl_PictPresDialog_Description)
        Me.IHpnl_bgpanel.Controls.Add(Me.LEXlbl_PictPresDialog_Title)

        For locationButtonColumn As Integer = 0 To 5
            For locationButtonRow As Integer = 0 To 3
                LEXbtn_PictPresDialog_LocationButton(locationButtonRow, locationButtonColumn) = _
                    New System.Windows.Forms.Button
                With Me.LEXbtn_PictPresDialog_LocationButton(locationButtonRow, locationButtonColumn)
                    Dim RowName As String() = {"A", "B", "C", "D"}
                    Dim ColumnName As String() = {"0", "1", "2", "3", "4", "5"}
                    .Location = New System.Drawing.Point(540 + locationButtonColumn * 38, 120 + locationButtonRow * 25)
                    .Name = "LEXbtn_PictPresDialog_LocationButton(" _
                            & locationButtonColumn.ToString _
                            & "," _
                            & locationButtonRow.ToString _
                            & ")"
                    .Font = New System.Drawing.Font("Microsoft Sans Serif", 8.0!, _
                        System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
                    .Size = New System.Drawing.Size(33, 20)
                    .Text = RowName(locationButtonRow) & ColumnName(locationButtonColumn)
                    .Tag = New List(Of Integer)(New Integer() {locationButtonRow, locationButtonColumn})
                End With
                Me.IHpnl_bgpanel.Controls _
                    .Add(Me.LEXbtn_PictPresDialog_LocationButton(locationButtonRow, locationButtonColumn))
                AddHandler Me.LEXbtn_PictPresDialog_LocationButton(locationButtonRow, locationButtonColumn).Click, _
                    AddressOf LEXbtn_PictPresDialog_LocationButton_Click
            Next
        Next

        Me.LEXbtn_workdialog_Continue.Text = "Start Run"
        Me.LEXrtb_workDlg_Textpane_Upper.Visible = False
        Me.LEXrtb_workDlg_Textpane_Lower.Visible = False

    End Sub

    Private Sub LEXdlg_Picture_presentation_dialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim appFolder As String = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), _
                Me.maestroMaster.GetGlobalVariableValue("g_ThisApplicationScreensPath"))
        'Dim appName As String = Me.maestroMaster.GetGlobalVariableValue("g_ApplicationName")'IH130724 not used
        Dim screenName As String = Me.maestroMaster.GetGlobalVariableValue("g_ScreenName")

        picturesAndTexts.Clear()

        Dim appFolderDirectoryInfo As New DirectoryInfo(Path.Combine(appFolder, screenName))
        Dim filesTxtInAppFolder As FileInfo() = appFolderDirectoryInfo.GetFiles("*.txt")
        Dim fileTxtInfo As System.IO.FileInfo
        Dim textLines As List(Of String) = New List(Of String)



        'IH130627 File name must be in the following format:
        ' either "Text_XX.txt", where XX is "A0","A1",...,"D4"
        ' or "TextN.txt", where N is "1","2","3",..,"10","11",...
        ' The corresponding picture files must be in the format
        ' either "Picture_XX.jpg", where XX is "A0","A1",...,"D4"
        ' or "PictureN.jpg", where N is "1","2","3",..,"10","11",...

        'IH131029 we can have a special file name 'Text_intro.txt' and 'Picture_intro.jpg'.
        'This will be shown as the first in the series.

        'IH150318 we can now also have a special file name 'Text_intro_N.txt' and 'Picture_intro_N.jpg'.
        ' where N is "1","2","3",..,"10","11",...
        'This will be shown immediately after Text_intro.txt/.jpg' in the enumerated order.

        'IH130627 we are only checking *.txt files. 
        ' .txt without .jpg WILL be displayed 
        ' .jpg without .txt WILL NOT be displayed
        For Each fileTxtInfo In filesTxtInAppFolder

            Dim r As Regex = New Regex("Text(?<fullId>(_(?<locationId>[A-D]{1}[0-5]{1}))|(?<simpleSerialNumber>[1-9]+[0-9]*)|(_(?<introTag>intro))|(_(intro_(?<introSerialNumber>[1-9]+[0-9]*))))\.txt")
            Dim m As Match = r.Match(fileTxtInfo.Name)
            Dim fullId As String = ""
            Dim locationId As String = ""
            Dim simpleSerialNumberString As String = ""
            Dim introSerialNumberString As String = ""
            If m.Success Then
                fullId = m.Groups("fullId").Value
                locationId = m.Groups("locationId").Value

                If String.IsNullOrEmpty(locationId) Then
                    simpleSerialNumberString = m.Groups("simpleSerialNumber").Value
                    introSerialNumberString = m.Groups("introSerialNumber").Value
                    If String.IsNullOrEmpty(simpleSerialNumberString) Then
                        If String.IsNullOrEmpty(introSerialNumberString) Then
                            'IH131029 the Text_intro.txt/.jpg is an ad hoc case
                            'IH131029 HACK trick here: we assign location '0' to the intro text/picture
                            'These will then come at the beginning after alphabetical sort
                            locationId = "0"
                        Else
                            'IH150318 files Text_intro_NN.txt/.jpg
                            locationId = "00" & Integer.Parse(m.Groups("introSerialNumber").Value).ToString("D4")
                        End If
                    Else
                        'IH130627 HACK trick here: we assign location 'XX+simpleSerialNumber(zero-left-padded)' to all non-explicitly located items.
                        'These will then come at the end after alphabetical sort 
                        locationId = "XX" & Integer.Parse(m.Groups("simpleSerialNumber").Value).ToString("D4")
                        'IH130627 this assumes we have 9999 non-located images max
                    End If
                End If
            End If


            ' read .txt file
            Dim text As String = ""
            Try
                Dim fileReader As System.IO.StreamReader = New StreamReader(fileTxtInfo.FullName)
                text = fileReader.ReadToEnd()
                fileReader.Close()
            Catch ex As Exception
                Me.maestroMaster.RaiseErrorFromVSTA(1004, "LEXdlg_Work_dialog:LEXdlg_Picture_presentation_dialog_Load", "Problems reading file " & fileTxtInfo.Name)
            End Try

            ' read .jpg file if any
            Dim picture As System.Drawing.Image = Nothing
            Dim fileJpgName As String = _
                Path.Combine(Path.GetDirectoryName(fileTxtInfo.FullName), "Picture" & fullId & ".jpg")
            If File.Exists(fileJpgName) Then
                Try
                    picture = System.Drawing.Image.FromFile(fileJpgName)
                Catch ex As Exception
                    Me.maestroMaster.RaiseErrorFromVSTA(1004, "LEXdlg_Work_dialog:LEXdlg_Picture_presentation_dialog_Load", "Problems reading file " & fileJpgName)
                End Try
            End If

            'insert into list
            picturesAndTexts.Add(New PictureAndText(locationId, picture, text))
        Next

        'IH130627 sort list so the non-located pictures come in correct order
        picturesAndTexts.Sort(AddressOf ComparePictureAndTextByLocationString)

        ' set up the GUI status
        If picturesAndTexts.Count <= 1 Then
            Me.LEXbtn_PictPresDialog_Previous.Enabled = False
            Me.LEXbtn_PictPresDialog_Next.Enabled = False
        End If
        For r As Integer = 0 To 3
            For c As Integer = 0 To 5
                With Me.LEXbtn_PictPresDialog_LocationButton(r, c)
                    .Enabled = False
                End With

                For Each pAndT As PictureAndText In picturesAndTexts
                    If pAndT.Location.Equals(RowAndColumnToLocationString(r, c)) Then
                        With Me.LEXbtn_PictPresDialog_LocationButton(r, c)
                            .Enabled = True
                        End With
                    End If
                Next
            Next
        Next

        If picturesAndTexts.Count = 0 Then
            actualPictureAndTextIndexToShow = -1 'IH130627 negative value indicates there are nothing to show
        Else
            actualPictureAndTextIndexToShow = 0
        End If

        UpdateGUIState()
        UpdatePictureAndText()

    End Sub

    Private Shared Function ComparePictureAndTextByLocationString(ByVal pt1 As PictureAndText, ByVal pt2 As PictureAndText) As Integer
        If pt1 Is Nothing Then
            If pt2 Is Nothing Then
                Return 0
            Else
                Return -1
            End If
        Else
            If pt2 Is Nothing Then
                Return 1
            Else
                Return pt1.Location.CompareTo(pt2.Location)
            End If
        End If
    End Function

    Private Sub SetActualLocationButton(ByVal row As Integer, ByVal column As Integer)
        'find the corresponding picture and text        
        For i As Integer = 0 To (picturesAndTexts.Count() - 1)
            If picturesAndTexts(i).Location.Equals(RowAndColumnToLocationString(row, column)) Then
                actualPictureAndTextIndexToShow = i
                'IH130627 it is guarranteed to reach this command since we only
                ' enabled location button which correspond to available entries in picturesAndTexts
                Exit For
            End If
        Next
        UpdateGUIState()
        UpdatePictureAndText()
    End Sub

    Private Function RowAndColumnToLocationString(ByVal row As Integer, ByVal column As Integer) As String
        Dim rowCode As String() = New String() {"A", "B", "C", "D"}
        Dim columnCode As String() = New String() {"0", "1", "2", "3", "4", "5"}
        Return rowCode(row) & columnCode(column)
    End Function

    Private Sub UpdatePictureAndText()

        Dim pictureToShow As System.Drawing.Image = My.Resources.No_picture_available
        Dim textToShow As String = "(No description available)"

        If actualPictureAndTextIndexToShow >= 0 Then
            With picturesAndTexts(actualPictureAndTextIndexToShow)
                If .Picture IsNot Nothing Then
                    pictureToShow = .Picture
                End If
                textToShow = .Text
            End With
        End If

        Me.LEXpcb_PictPresDialog_Image.Image = pictureToShow
        Me.LEXlbl_PictPresDialog_Description.Text = textToShow

    End Sub

    Private Sub ShiftPictureAndTextToShowUp()
        actualPictureAndTextIndexToShow = actualPictureAndTextIndexToShow + 1
        UpdateGUIState()
        UpdatePictureAndText()
    End Sub

    Private Sub ShiftPictureAndTextToShowDown()
        actualPictureAndTextIndexToShow = actualPictureAndTextIndexToShow - 1
        UpdateGUIState()
        UpdatePictureAndText()
    End Sub

    Private Sub UpdateGUIState()

        Me.LEXbtn_PictPresDialog_Previous.Enabled = (actualPictureAndTextIndexToShow > 0)
        Me.LEXbtn_PictPresDialog_Next.Enabled = (actualPictureAndTextIndexToShow < picturesAndTexts.Count - 1)

        With Me.LEXlbl_PictPresDialog_LocationLabel
            .Visible = False
        End With

        For r As Integer = 0 To 3
            For c As Integer = 0 To 5

                With Me.LEXbtn_PictPresDialog_LocationButton(r, c)
                    If .Enabled Then
                        .BackColor = Me.buttonBgColorEnabled
                        .ForeColor = Me.buttonFgColorEnabled
                    Else
                        .BackColor = Me.buttonBgColorDisabled
                        .ForeColor = Me.buttonFgColorDisabled
                    End If
                End With

                If actualPictureAndTextIndexToShow >= 0 Then                    
                    If picturesAndTexts(actualPictureAndTextIndexToShow).Location.Equals(RowAndColumnToLocationString(r, c)) Then
                        With Me.LEXbtn_PictPresDialog_LocationButton(r, c)
                            .BackColor = Me.buttonBgColorSelected
                            .ForeColor = Me.buttonFgColorSelected
                        End With
                        With Me.LEXlbl_PictPresDialog_LocationLabel
                            .Visible = True
                            .Text = RowAndColumnToLocationString(r, c)
                        End With
                    End If
                End If
            Next
        Next

    End Sub

    Private Sub LEXbtn_PictPresDialog_LocationButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim Btn As Button = DirectCast(sender, Button)
        'IH130625 the indices of the button are encoded in the tag as a list
        Dim indexList As List(Of Integer) = DirectCast(Btn.Tag, List(Of Integer))
        Dim locationButtonRow As Integer = indexList(0)
        Dim locationButtonColumn As Integer = indexList(1)

        SetActualLocationButton(locationButtonRow, locationButtonColumn)
    End Sub

    Private Sub LEXbtn_PictPresDialog_Next_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LEXbtn_PictPresDialog_Next.Click
        ShiftPictureAndTextToShowUp()
    End Sub

    Private Sub LEXbtn_PictPresDialog_Previous_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LEXbtn_PictPresDialog_Previous.Click
        ShiftPictureAndTextToShowDown()
    End Sub

    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing AndAlso components IsNot Nothing Then
            components.Dispose()
        End If
        MyBase.Dispose(disposing)
    End Sub

    Friend WithEvents LEXbtn_PictPresDialog_Next As System.Windows.Forms.Button
    Friend WithEvents LEXbtn_PictPresDialog_Previous As System.Windows.Forms.Button
    Friend WithEvents LEXpcb_PictPresDialog_Image As System.Windows.Forms.PictureBox
    Friend WithEvents LEXlbl_PictPresDialog_LocationLabel As System.Windows.Forms.Label
    Friend WithEvents LEXlbl_PictPresDialog_Description As System.Windows.Forms.Label
    Friend WithEvents LEXlbl_PictPresDialog_Title As System.Windows.Forms.Label
    Friend LEXbtn_PictPresDialog_LocationButton(4, 6) As System.Windows.Forms.Button

    Private Class PictureAndText
        Public Location As String  'typically 'A1' to 'D4' or ''
        Public Picture As System.Drawing.Image
        Public Text As String

        Sub New(ByVal loc As String, ByVal pict As System.Drawing.Image, ByVal txt As String)
            Location = loc
            Picture = pict
            Text = txt
        End Sub
    End Class

End Class

